/* HalWatch.h -*- c++ -*- Time-stamp: <2006/03/21 21:38 haru@XP4PDA05C>
 *   for HalWatch modules
 * (C) 2005 HAL <http://hal9.blog3.fc2.com> HAL.Kinosita@gmail.com
 */

#ifndef __HALWATCH_H__
#define __HALWATCH_H__


/* (E)Required for HalWatch module. These value must be set as tSTR(1)="HalWatch_Module".
 * (J)HalWatch ̃W[ƂĔF邽߂ɂ ID=1  tSTR \[X "HalWatch_Module" ݒ肵Ȃ΂ȂȂB
 */

#define HalWatchModuleIdent_StrResID 1
#define HalWatchModuleIdent_String   "HalWatch_Module"


/* (E)if *.rcp includs this, define __RSC__ just before #include line
 * (J)\[Xt@C炱̃t@CCN[h鎞́C
 * CN[hO #define __RSC__ ƂĂ
 * \[Xŉ߂łȂȍ~̓e͓ǂݍ܂Ȃ
 */
#ifndef __RSC__ 


#include <PalmOS.h>


/* (E)followings are optional. not neccesary to be used 
 * (J)ȉ̓IvVBKgȂĂǂ 
 */

#define HalWatchDbName    "!HalWatch"
#define HalWatchOldDbName "HalWatch"



/* (E)definition of parameters passing to a module
 * (J)HalWatch 烂W[ɓnϐ
 * W[ PilotMain()  cmdPBP  HalWatchGlobals_t \̂ւ̃|C^^ċNB
 */

/* (E)typedef of redraw level parameter
 * (J)XVx̎w HalWatchRedrawLevel_t 
 */
typedef enum { 
	RL_All =0, /* W[؂ւȂǁCSʕ`悪Kvȏꍇ */
	RL_Day =1, /* CC  XVꍇ */
	RL_Hour=2, /*     C  XVꍇ */
	RL_Min =3  /*         ̂ݍXVꍇ */
} HalWatchRedrawLevel_t;

/* (E) available ID for HalWatchGlobals_t::customCmdID
 * (J) HalWatchGlobals_t::customCmdID Ƃ肤l
 */
#define CustomCmdID_NULL 0
#define CustomCmdID1 1
#define CustomCmdID2 2
#define CustomCmdID3 3
#define CustomCmdID4 4
/* ID 5,6 is used interanlly */
#define CustomCmdID_RockerUp   7
#define CustomCmdID_RockerDown 8

/* (E)function that can be used in a module
 * (J)W[ĂяoƂ̏o֐̌^` 
 */
typedef Int32 (*int1024xSinPtr_t)(Int16 th); /* (J)1024 {ꂽl𐮐lƂĕԂ sin() ֐ւ̃|C^^B6x */

/* (E)a pointer to HalWatchGlobals_t is given as cmdPBP in a module's PilotMain()
 * (J)HalWatch 烂W[ɓnϐQ̍\ HalWatchGlobals_t 
 * ̃|C^ cmdPBP ƂăW[ɓn                
 */ 
typedef struct {
	UInt32                usrVar32       ; /* W[̏ԂۑϐBۑǗ HalWatch ōsB*/
	                                       /*   𗘗p 32bit Ŏ܂Ȃ烂W[     */
	                                       /*   p[^̃[h^Z[u̎ԂȂ                  */
	UInt8                 customCmdID    ; /* L[Ɋ蓖ĉ\ȃJX^R}h̔ԍ (1 ~ 4) */
	DateTimeType          cDateTime      ; /* ݎi[\ */
	UInt8                 percentBattery ; /* obec(%)̒l          */
	UInt16                volx100        ; /* d(̕S{)̒l             */
	Boolean               isOnPower      ; /* dɐڑ=1 dr쓮=0      */
	HalWatchRedrawLevel_t redrawLevel    ; /* XVx̎w HalWatchRedrawLevel_t */
	int1024xSinPtr_t      ptr1024sin     ; /* 1024 {ꂽl𐮐lƂĕԂ sin() ֐ւ̃|C^B1x */
} HalWatchGlobals_t; 

/* (E)sample code, how to use ptr1024sin function in a module
 * (J)int1024xSinPtr_t ptr1024sin; ̃W[ł̎g̈BSĐ^ϐŊpx̌vZsB
#define IntSin(ptr, th) (ptr->ptr1024sin)(th)
#define IntCos(ptr, th) (ptr->ptr1024sin)(th+90)
PilotMain(UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags){
  switch(cmd){
    default: break;
    case wpdaAppLaunchWatchFaceNext:
    case wpdaAppLaunchWatchFacePrev:
    case wpdaAppLaunchWatchDrawTime:
      WinEraseWindow(); // Sʏ
      {
        HalWatchGlobals_t* gP = (HalWatchGlobals_t*)cmdPBP;
        Int16 theta = 6 * gP->cDateTime.minute; // Zj̊px 60 min = 360 deg
        Int16 handCenterXpos = 80;              // Zj̒SW
        Int16 handLength = 50;                  // Zj̒
        Int16 handEndXpos = handCenterXpos;     // Zj̏I_W
        handEndXpos += ( ( handLength * IntSin( gP,  theta ) ) >> 10 ); // I_W̌vZF|Z 10 bit Vtg(1024ł̊Z)
        // y W IntCos() pēlɌvZ
        WinDrawLine(handCenterXpos, handCenterYpos, handEndXpos, handEndYpos); // Zj̕`
        // ̑jȂǂ`悷
      }
  }
  return errNone;
}
*/


/* (E)if module return 'HalWatchReturnCodeRequestFinalize', 
 *    that module will be called at the end of Watch Mode (or HalWatchMgr).
 *    with HalWatchLaunchCmdFinalize (as cmd arg in PilotMain())
 *    If an initialize process is too heavy, this framework may be useful.
 * (J) 
 * - W[ HalWatch ɂČĂяoꂽꍇɂ́Cv[hPDA[h̎
 *   ̃W[ SysAppLaunch() ŌĂяoĂ炤ƂoB 
 * - ̌Ăяo󂯂ɂ̓W[ԂlƂ HalWatchReturnCodeRequestFinalize ԂȂ΂ȂȂB
 * - W[͂̌Ăяo𗘗pă̊JȂǂsƂoB
 * - ʂ̕\⏑Ȃǂ͍sȂقǂB
 * - ł΂̋NR[hɗ炸ɖ񏈗͊Ă邱Ƃ]܂
 *   ɑȃRXg|薈񃁃̎擾-vZ-JJԂ̂
 *   ȏꍇɎgp邱Ƃz肵ĂB
 */

/* (J)INvFW[ HalWatch Ăяoꂽɂ̒l return ŕԂƂŏÎ߂ɋN悤ɂȂ 
 * KvȂ errNone (0) ԂΗǂB
 */
#define HalWatchReturnCodeRequestFinalize 0x0001

/* (J)INR[hFNvĂPDA[hɖ߂鎞ɃW[͂̋NR[hŌĂяo */
#define HalWatchLaunchCmdFinalize (sysAppLaunchCmdCustomBase + 104)



/* (J)
#define halwAppLaunchCmdQueryDefault (sysAppLaunchCmdCustomBase + 99)

typedef struct {
	Boolean isReadyForQueryLaunch;
} HalWatchQueryDefault_t;
*/



#endif /*#ifndef __RSC__*/
#endif /*#ifndef __HALWATCH_H__*/
