// hwvTimeTable.cpp Time-stamp: <2006/03/24 21:43 haru@XP4PDA05C>
//   HalWatch module : Viewer of TimeTable 1.3
//                     Original TimeTable is made by Hiroaki Sengoku <sengoku@gcd.org> http://www.gcd.org/sengoku/
// (C) 2005-2006 HAL <http://hal9.blog3.fc2.com> HAL.Kinosita@gmail.com

/*
 * TimeTable Viewer
 * Copyright(c)1999 by Hiroaki Sengoku <sengoku@gcd.org>
 * Version 0.1	Jun 19, 1999
 * Version 0.2	Jun 20, 1999
 * Version 0.3	Jun 20, 1999
 * Version 0.4	Jun 21, 1999
 * Version 0.5	Jun 22, 1999	AboutDialog
 * Version 0.6	Jun 25, 1999	SelectTrain, HardButton, PrefsDialog
 * Version 0.7	Jun 26, 1999	scroll bug fix
 * Version 0.8	Jul  3, 1999	Arrive, ShareReg, History, Transfer, StopClock
 * Version 0.9	Jul  8,	1999	multi '>', ContFile, CommentMark, scramble
 * Version 1.0	Jul 31, 1999	split bar, DB, ;;CANCEL, '\' esc, HeadType, LRU
 * Version 1.1	Aug 26, 1999	checkTimeOut
 * Version 1.2	Aug 27, 2000	Alarm, InstalledSec, LastUsedSec
 * Version 1.3  Aug  1, 2001	GPL version
 */

#include <PalmOS.h>

//#include <Standalone.h>
//STANDALONE_CODE_RESOURCE_TYPESTR_ID("code", 1000);

#include <StdIOPalm.h>
#include <WristPDA.h>
//#include "HalWatch.h"
//#include "hwUtils.h"
#include "hwvTimeTable_rsc.h"
#define HwvTimeTable_Main 1
#include "hwvTimeTable.h"
#undef HwvTimeTable_Main

#define UseGlobalReplace 0
#define UseStackReplace  1

#if UseGlobalReplace
register struct globals *curA4 asm("%a4");
//#define    SAVE_A4_REGISTER struct globals *orgA4 = curA4; asm("move.l %%a5,%%a4; sub.l #edata,%%a4" : :); // for .c
//#define    SAVE_A4_REGISTER struct globals *orgA4 = curA4; asm ("move.l %a5,%a4; sub.l #edata,%a4" : :);   // for .cpp
#define    SAVE_A4_REGISTER struct globals *orgA4 = curA4; asm("move.l %%a5,%%a4; sub.l #edata,%%a4" : :);
#define RESTORE_A4_REGISTER                 curA4 = orgA4;
#endif

#if UseStackReplace
register void *reg_a7 asm("%sp");
#define __getA7()   (long) reg_a7
#define __setA7(a7) reg_a7 = (void *) (a7)
#define STACKSZ 4000
#endif

/*
UInt32 DAMain(UInt16 cmd, HalWatchGlobals_t *gP){
	UInt32 ret = errNone;

#if UseStackReplace	
	long  orgStack;
	void *newStack = (void *)MemPtrNew(STACKSZ); // X^bN̏
	if(newStack != NULL){ 
#endif
#if UseGlobalReplace
		SAVE_A4_REGISTER
#endif			
#if UseStackReplace	
			orgStack = __getA7();
		__setA7((long) newStack + STACKSZ);                    // X^bNu
#endif
		
		ret = myMain(cmd, gP);
		
#if UseStackReplace	
				__setA7(orgStack);                                     // X^bN߂
				MemPtrFree((void *)newStack);
#endif
#if UseGlobalReplace
				RESTORE_A4_REGISTER
#endif
#if UseStackReplace
			}
#endif

	return ret; 
}
*/

//========== Ftr ̊Ǘ ==========================================================================================
TimeTableGlobals_t* getPtrTimeTableGlobals(void){
	TimeTableGlobals_t* gTTP = NULL;
	HwvTimeTablePref_t hwvTimeTablePref;
	UInt16 prefSz;
	int itr;

	if(FtrGet(HwvTimeTable_CrtrID, FtrID_TimeTableGlobals, (UInt32*)&gTTP) //tB[`̎擾݂
		 == 0 && gTTP != NULL) return gTTP;                                  //ݒς݂Ȃ璼ɏI

	//----- tB[`ݒȂ烁m
	if(gTTP != NULL) MemPtrFree(gTTP);
	gTTP = (TimeTableGlobals_t*)MemPtrNew(sizeof(TimeTableGlobals_t)); //̈m
	//if(gTTP == NULL) WinDrawLine(0, 80, 159, 80);
	MemPtrSetOwner(gTTP, 0);                                           //L҂OSɂăVXeŜQƉ\
	MemSet(gTTP, 0, (UInt8)(sizeof(TimeTableGlobals_t)));              //[NA
	FtrSet(HwvTimeTable_CrtrID, FtrID_TimeTableGlobals, (UInt32)gTTP); //tB[`Ƀ̏ꏊۑ

	//Char hoge[16]; StrPrintF(hoge, "M%d", (int)sizeof(*gTTP));
	//WinDrawChars(hoge, StrLen(hoge), 15, 5);

	//----- hwvTimeTable Ǝ preference ̃[h
	prefSz = sizeof(HwvTimeTablePref_t);
	if(PrefGetAppPreferences(HwvTimeTable_CrtrID, PrefID_HwvTimeTable, &hwvTimeTablePref, &prefSz, IsSavedPref)
		 != HwvTimeTablePrefVerNo){
		hwvTimeTablePref.layoutID        = LO_Org;
		hwvTimeTablePref.cFileMenuItemID = 0;
		hwvTimeTablePref.orgHistoryCur   = -1;
		//hwvTimeTablePref.hwvHistoryCur   = -1;
		//
		hwvTimeTablePref.hwvUnsave.version     = -1; //-1=
		hwvTimeTablePref.hwvUnsave.SelLine     = -1;
		hwvTimeTablePref.hwvUnsave.SelItem     = -1;
		hwvTimeTablePref.hwvUnsave.OfsArrive   = 0;
		hwvTimeTablePref.hwvUnsave.NLines      = -1;
		hwvTimeTablePref.hwvUnsave.SelStn      = 0;
		hwvTimeTablePref.hwvUnsave.StnTop      = 0;
		hwvTimeTablePref.hwvUnsave.StnSepWidth = 0;
		hwvTimeTablePref.hwvUnsave.ListTop     = 0;
		hwvTimeTablePref.hwvUnsave.ManualSelectFlag    = false;
		hwvTimeTablePref.hwvUnsave.LargeClockFlag      = true;
		hwvTimeTablePref.hwvUnsave.ShowCommentsFlag    = false;
		hwvTimeTablePref.hwvUnsave.ShowArrivesFlag     = false;
		hwvTimeTablePref.hwvUnsave.Today               = Monday;
		hwvTimeTablePref.hwvUnsave.TodaySetSeconds     = 0;
		hwvTimeTablePref.hwvUnsave.timSeconds          = 0;
		hwvTimeTablePref.hwvUnsave.ConfigRecordNum     = -1;
		hwvTimeTablePref.hwvUnsave.TrainTimeRecordNum  = -1;
		for(itr=0; itr < HISTORYMAX; itr++) {
			hwvTimeTablePref.hwvUnsave.History[itr] = -1;
			hwvTimeTablePref.hwvUnsave.HisAttr[itr].StopClock        = 0;
			hwvTimeTablePref.hwvUnsave.HisAttr[itr].ManualSelectFlag = false;
			hwvTimeTablePref.hwvUnsave.HisAttr[itr].SelItem          = -1;
			hwvTimeTablePref.hwvUnsave.HisAttr[itr].SelLine          = -1;
		}
		hwvTimeTablePref.hwvUnsave.HistoryTop = -1; //0;
		hwvTimeTablePref.hwvUnsave.HistoryCur = -1; //0;
		hwvTimeTablePref.hwvUnsave.HistoryBot = -1; //0;
		hwvTimeTablePref.hwvUnsave.LRU_Top    = 0;
		for(itr=0; itr < LRU_MAX; itr++) {
			hwvTimeTablePref.hwvUnsave.LRU[itr].next      = itr+1;
			hwvTimeTablePref.hwvUnsave.LRU[itr].recordNum = -1;
		}
		PrefSetAppPreferences(HwvTimeTable_CrtrID, PrefID_HwvTimeTable, HwvTimeTablePrefVerNo, &hwvTimeTablePref, prefSz, IsSavedPref);
	}

	//----- lݒ
#ifdef DEBUGLINE
	gTTP->cDbgLnNo = 0;
	gTTP->cDbgCmtNo=0;
#endif 
	gTTP->gHWP            = NULL;
	gTTP->isNoData     = false;
	gTTP->halLayoutID     = hwvTimeTablePref.layoutID;
	gTTP->isNarrowModeInvert = false;
	gTTP->cFileMenuItemID = hwvTimeTablePref.cFileMenuItemID;
	gTTP->font4table      = stdFont;
	gTTP->font4Note       = largeFont;
	gTTP->fontB4Note      = largeBoldFont;
	gTTP->font4NoteTop    = FossilLargeFont;
	//gTTP->font4CTime      = FossilLargeBoldFont;
	gTTP->font4Title      = largeFont;
	//gTTP->isShrinkTable   = true;

	/**/
	//>>Main.c
	gTTP->PrivErrExtraStr = NULL;
	gTTP->LastSec         = 0   ;
	//gTTP->CurrentMenuBar  = NULL:
	gTTP->PrefsCategory   = 0;

	//>>Table.c
	gTTP->CurrentTable         = NULL;
	gTTP->ArriveTime           = NULL;
	for(itr=0; itr < ArrivesColumnMax; itr++)
		gTTP->ArriveTimeHead[itr]	
			= gTTP->ArriveTimeHeadMark[itr] = 0;
	gTTP->NextTrain            = 0   ;
	gTTP->TicksPerSeconds      = SysTicksPerSecond();
	for(itr=0; itr < NNumBitmaps; itr++) 
		gTTP->NumBitmap[itr]     = NULL;
	gTTP->AlarmBitmap          = NULL;
	gTTP->StartupFlag          = true;
	//gTTP->MainFormPtr          = NULL;
	gTTP->AlarmDialogFlag      = false;
	gTTP->AlarmMinute          = -1; //getAlarm();
	gTTP->AlarmMinuteSave      = gTTP->AlarmMinute;
	gTTP->AlarmTapCount        = 0;
	//gTTP->NarrowOrgItemsText   = NULL;
	gTTP->ConfigRecordNum      = -1;
	gTTP->TrainTimeRecordNum   = -1;
	gTTP->LargeClockFlag       = true;
	for(itr=0; itr < ExCommentsMax; itr++) 
		gTTP->CommentsTmp[itr]   = 0;
	gTTP->ShowCommentsFlag     = false;
	gTTP->SelLine              = -1;
	gTTP->SelItem              = -1;
	gTTP->ManualSelectFlag     = false;
	gTTP->LargeClockFreq       = Mostly;
	gTTP->UnderlineSpecialFlag = true;
	gTTP->ScrollByKeyFlag      = false;
	gTTP->ShowArrivesFlag      = false;
  gTTP->ArriveBarFlag = false;
  gTTP->ArriveRightX = 0;
	gTTP->OfsArrive            = 0;
	gTTP->NarrowMode           = -1;
	gTTP->NarrowModeORG        = -1; //byHAL
	gTTP->NarrowModeDefault    = -1;
	gTTP->TwelveFlag           = false;
	gTTP->OmitHourFlag         = false;
	gTTP->ArrivesColumn        = 4;
	gTTP->ArriveTimeHeadType   = HeadNone;
	gTTP->StopClockInterval    = 1;
	gTTP->ChooseStartupFlag    = false;
	//gTTP->NLines               = -1;
	gTTP->TransNLines          = 0;
	gTTP->BorderMin            = -3;	
	gTTP->HistoryTop           = -1; //0;
	gTTP->HistoryCur           = -1; //0;
	gTTP->HistoryBot           = -1; //0;
	for(itr=0; itr < HISTORYMAX; itr++) {
		gTTP->History[itr]         = -1;
		gTTP->HisAttr[itr].StopClock        = 0;
		gTTP->HisAttr[itr].ManualSelectFlag = false;
		gTTP->HisAttr[itr].SelItem          = -1;
		gTTP->HisAttr[itr].SelLine          = -1;
	}
	//initLRU(); //gTTP->LRU;
	for(itr=0; itr < LRU_MAX; itr++) {
		gTTP->LRU[itr].next = itr+1;
		gTTP->LRU[itr].recordNum = -1;
	}
	gTTP->LRU[LRU_MAX-1].next = -1;
	gTTP->LRU_Top = 0;
	//gTTP->MainMenuBar      = NULL;
	gTTP->OffScreen        = NULL;
	gTTP->OffScreenErr     = 0;
	//gTTP->MoveMenuItemStrH = NULL;
	gTTP->ItemWidth  = 13; //KbyHAL
	gTTP->ItemHeight = 12; //KbyHAL
	gTTP->TableX = TimeTablePos_X0; //KbyHAL
	gTTP->TopY = TimeTablePos_Y0; //KbyHAL
	gTTP->TableY = gTTP->TopY + gTTP->ItemHeight;
	gTTP->NItems = ScreenX / gTTP->ItemWidth;
	gTTP->NLines = -1;
	gTTP->NLinesORG = -1;
	gTTP->TimeWidth = 40;
	gTTP->TimeHeight = 10;
	gTTP->TimeX = ScreenX - 3 - gTTP->TimeWidth;
	gTTP->TimeY = 1;
	gTTP->TimeLeftX = 82;
	gTTP->TimeLeftColonX = gTTP->TimeLeftX + 18;
	gTTP->BoldColonWidth = 5;
	gTTP->NormalClockRect.topLeft.x = gTTP->TimeLeftX;
	gTTP->NormalClockRect.topLeft.y = gTTP->TimeY;
	gTTP->NormalClockRect.extent.x = 45;
	gTTP->NormalClockRect.extent.y = 10;
	gTTP->AlarmRect.topLeft.x = gTTP->TimeX - AlarmSize;
	gTTP->AlarmRect.topLeft.y = 0;
	gTTP->AlarmRect.extent.x = AlarmSize;
	gTTP->AlarmRect.extent.y = AlarmSize;
	gTTP->StnX = 0;
	gTTP->StnXLower = 0;
	gTTP->StnExtent = 0;
	gTTP->ClockInvertedFlag = false;
	gTTP->StopClock = 0;
	//gTTP->OrgAppDbRef = NULL;
	gTTP->OfsItem = 0;
	gTTP->OfsLine = 0;
	gTTP->NarrowEndX = TimeTablePos_X0; //KbyHALB Table.c::setupNarrowPopup()Őݒ
	//>>Table.c

	//>>List.c
	//gTTP->StnTrains   = NULL;
	//gTTP->StnNameBuf  = NULL;
	//gTTP->AllTrains   = NULL;
	//gTTP->Trains      = NULL;
	//gTTP->ListFormPtr = NULL;
	//gTTP->ListMenuBar = MenuInit(TableListMenu);
	gTTP->ListOrder = ListOrder_DB_Memo;
	gTTP->ListTop = 0;
	gTTP->StnTop = 0;
	gTTP->SelStn = 0;
	gTTP->StnSepWidth = 0;

	//>>DB.c
	gTTP->TimeTableDB       = NULL;
	gTTP->MemoDB            = NULL;
	gTTP->TrainTimeCategory = 0;
	gTTP->InsertPosMemo     = InsertPosBot; //InsertPosAlphabetical;
	gTTP->InsertPosDB       = InsertPosBot;
	gTTP->TodaySetSeconds   = 0;
	setToday(false); //gTTP->Today = Errday;
	gTTP->TodayDate         = Errday;
	gTTP->ConfigHandle      = NULL;
	gTTP->TimeTableCategory = 0;
	gTTP->TimeTableAppInfoH = NULL;
	gTTP->ContFileNo       = 0;
	gTTP->NContFiles       = 0;
	gTTP->ContFileRecNo    = 0;
	gTTP->ContFileHandle   = NULL;
	gTTP->ContFileLastLine = NULL;
	for(itr=0; itr<STRLINEMAX; itr++)
		gTTP->ContFileLastLineBuf[itr] = '\0';
	gTTP->ContFileNextLine = NULL;
	gTTP->CommentMark      = Mark;
	for(itr=0; itr<0x1F+1; itr++)
		gTTP->DotPattern[itr] = 0;
	for(itr=0; itr<NComments+1; itr++)
		gTTP->NarrowList[itr] = 0;
	for(itr=0; itr<STRMAX; itr++){
		gTTP->ContFileName[itr] = '\0';
		gTTP->Title[itr] = '\0';
	}

	//>>Dialog.c
	for(itr=0; itr < SeparatorMapLen; itr++)
		gTTP->SeparatorMap[itr] = 0;
	gTTP->MidiIndex = 0;
	gTTP->MinBefore = 3;
	gTTP->PrevTime = 0;
	/**/

	return gTTP;
}

void freePtrTimeTableGlobals(TimeTableGlobals_t* gTTP){
	HwvTimeTablePref_t hwvTimeTablePref;
	UInt16 prefSz;
	Int16 i;
	FtrUnregister(HwvTimeTable_CrtrID, FtrID_TimeTableGlobals);
	if(gTTP == NULL) return;

	//----- hwvTimeTable Ǝ preference ̏߂
	prefSz = sizeof(HwvTimeTablePref_t);
	if(PrefGetAppPreferences(HwvTimeTable_CrtrID, PrefID_HwvTimeTable, &hwvTimeTablePref, &prefSz, IsSavedPref)
		 != HwvTimeTablePrefVerNo){
		hwvTimeTablePref.orgHistoryCur     = -2; //gTTP->HistoryCur;
		hwvTimeTablePref.hwvUnsave.version = -1; //-1=
	}
	hwvTimeTablePref.layoutID        = gTTP->halLayoutID;
	hwvTimeTablePref.cFileMenuItemID = 0; //gTTP->cFileMenuItemID;
	//hwvTimeTablePref.hwvHistoryCur = gTTP->HistoryCur;
	//while(hwvTimeTablePref.hwvHistoryCur <  0         ) hwvTimeTablePref.hwvHistoryCur += HISTORYMAX;
	//while(hwvTimeTablePref.hwvHistoryCur >= HISTORYMAX) hwvTimeTablePref.hwvHistoryCur -= HISTORYMAX;
	hwvTimeTablePref.hwvUnsave.version = TimeTableUnsaveVersion;
	if(gTTP->ManualSelectFlag) {
		hwvTimeTablePref.hwvUnsave.SelLine = gTTP->SelLine;
		hwvTimeTablePref.hwvUnsave.SelItem = gTTP->SelItem;
	} else {
		hwvTimeTablePref.hwvUnsave.SelLine = -1;
		hwvTimeTablePref.hwvUnsave.SelItem = -1;
	}
	hwvTimeTablePref.hwvUnsave.ManualSelectFlag   = gTTP->ManualSelectFlag;
	hwvTimeTablePref.hwvUnsave.OfsArrive          = gTTP->OfsArrive;
	hwvTimeTablePref.hwvUnsave.NLines             = gTTP->NLines;
	hwvTimeTablePref.hwvUnsave.SelStn             = gTTP->SelStn;
	hwvTimeTablePref.hwvUnsave.StnSepWidth        = gTTP->StnSepWidth;
	hwvTimeTablePref.hwvUnsave.StnTop             = gTTP->StnTop;
	hwvTimeTablePref.hwvUnsave.ListTop            = gTTP->ListTop;
	hwvTimeTablePref.hwvUnsave.LargeClockFlag     = gTTP->LargeClockFlag;
	hwvTimeTablePref.hwvUnsave.ShowCommentsFlag   = gTTP->ShowCommentsFlag;
	hwvTimeTablePref.hwvUnsave.ShowArrivesFlag    = gTTP->ShowArrivesFlag;
	hwvTimeTablePref.hwvUnsave.Today              = gTTP->Today;
	hwvTimeTablePref.hwvUnsave.TodaySetSeconds    = gTTP->TodaySetSeconds;
	hwvTimeTablePref.hwvUnsave.timSeconds         = (gTTP->gHWP) ? TimDateTimeToSeconds(&(gTTP->gHWP->cDateTime)) : TimGetSeconds();
	hwvTimeTablePref.hwvUnsave.ConfigRecordNum    = gTTP->ConfigRecordNum;
	hwvTimeTablePref.hwvUnsave.TrainTimeRecordNum = gTTP->TrainTimeRecordNum;
	for (i=0; i < HISTORYMAX; i++) hwvTimeTablePref.hwvUnsave.History[i] = gTTP->History[i];
	hwvTimeTablePref.hwvUnsave.HistoryTop = gTTP->HistoryTop;
	hwvTimeTablePref.hwvUnsave.HistoryCur = gTTP->HistoryCur;
	hwvTimeTablePref.hwvUnsave.HistoryBot = gTTP->HistoryBot;
	for (i=0; i < HISTORYMAX; i++) hwvTimeTablePref.hwvUnsave.HisAttr[i] = gTTP->HisAttr[i];
	for (i=0; i < LRU_MAX   ; i++) hwvTimeTablePref.hwvUnsave.LRU[i]     = gTTP->LRU[i];
	hwvTimeTablePref.hwvUnsave.LRU_Top = gTTP->LRU_Top;

	PrefSetAppPreferences(HwvTimeTable_CrtrID, PrefID_HwvTimeTable, HwvTimeTablePrefVerNo, &hwvTimeTablePref, prefSz, IsSavedPref);

	//----- J
	//--- Table.c::closeTable()
	//unselectItem();
	//if (gTTP->NarrowOrgItemsText && gTTP->MainFormPtr) {
	//	ListPtr list;
	//	UInt16 lindex;
	//	lindex = FrmGetObjectIndex(gTTP->MainFormPtr,MainPopupListNarrow);
	//	list = FrmGetObjectPtr(gTTP->MainFormPtr,lindex);
	//	list->itemsText = gTTP->NarrowOrgItemsText;
	//	list->numItems = gTTP->NarrowOrgNumItems;
	//	list->bounds.extent.x = gTTP->NarrowOrgItemWidth;
	//	gTTP->NarrowOrgItemsText = NULL;
	//}
	if(gTTP->CurrentTable != NULL){
		disposeTimeTable(gTTP->CurrentTable);
		gTTP->CurrentTable = NULL;
	}
	if(gTTP->ArriveTime){
		MemPtrFree(gTTP->ArriveTime);
		gTTP->ArriveTime = NULL;
	}
	for(i=0; i < NNumBitmaps; i++){
		if(gTTP->NumBitmap[i]){
	    DmReleaseResource(gTTP->NumBitmap[i]);
	    gTTP->NumBitmap[i] = NULL;
		}
	}
	if(gTTP->AlarmBitmap) 
		DmReleaseResource(gTTP->AlarmBitmap);
	if(gTTP->OffScreen){
		WinDeleteWindow(gTTP->OffScreen, false);
		gTTP->OffScreen = NULL;
	}
	//--- List.c::closeList()
	//if (gTTP->StnTrains) {
	//	MemPtrFree(gTTP->StnTrains);
	//	gTTP->StnTrains = NULL;
	//}
	//if (gTTP->StnNameBuf) {
	//	MemPtrFree(gTTP->StnNameBuf);
	//	gTTP->StnNameBuf = NULL;
	//}
	//if (gTTP->AllTrains) {
	//	MemPtrFree(gTTP->AllTrains);
	//	gTTP->AllTrains = NULL;
	//}
	//gTTP->Trains = NULL;
	//---
	if(gTTP->MemoDB      != NULL) DmCloseDatabase(gTTP->MemoDB     );
	if(gTTP->TimeTableDB != NULL) DmCloseDatabase(gTTP->TimeTableDB);
	//---
	MemPtrFree(gTTP);
}

#ifdef DEBUGLINE
void DEBUG_LINE(Int16 num){
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	Char buf[8]; 

	if(num >= 0) gTTP->cDbgLnNo = num;
	WinDrawLine(0, 159 - gTTP->cDbgLnNo * 4, 159, 159 - 4 - gTTP->cDbgLnNo * 4);
	StrPrintF(buf, "D%d", gTTP->cDbgLnNo);
	WinDrawChars(buf, StrLen(buf), 3, 3);
	gTTP->cDbgLnNo++;
}
#endif

//========== Dialog.c ============================================================================================
Int16 getAlarm(void) {
	UInt16 cardNo;
	LocalID dbID;
  UInt32 ref;
	UInt32 sec;
	DmSearchStateType searchInfo;
	DmGetNextDatabaseByTypeCreator(true, &searchInfo, sysFileTApplication, APPID, true, &cardNo, &dbID);
	sec = AlmGetAlarm(cardNo, dbID, &ref);
	if(sec){
		DateTimeType dateTime;
		TimSecondsToDateTime(sec, &dateTime);
		return dateTime.hour * 60 + dateTime.minute;
	}
	return -1;
}

void setSeparator(UInt8 *p) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	UInt8 c;
	int itr;
	for(itr=0; itr < SeparatorMapLen; itr++) 
		gTTP->SeparatorMap[itr] = 0;
	while(*p){
		c = *p++;
		c -= ' ';
		gTTP->SeparatorMap[c >> 3] |= (0x80 >> (c & 0x7));
	}
}

//========== DB.c ================================================================================================

//========== Table.c =============================================================================================

//========== List.c ==============================================================================================
void initializeList(void) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	MemHandle strH;

	//gTTP->StnTrains   = NULL;
	//gTTP->StnNameBuf  = NULL;
	//gTTP->AllTrains   = NULL;
	//gTTP->Trains      = NULL;
	//gTTP->ListFormPtr = NULL;
	//gTTP->ListMenuBar = MenuInit(TableListMenu);
	gTTP->TimeTableDB = NULL;
	strH = DmGetResource('tSTR', SeparatorStr);
	if(strH) {
		setSeparator((UInt8*)MemHandleLock(strH));
		MemHandleUnlock(strH);
		DmReleaseResource(strH);
	} else {
		setSeparator((UInt8*)" !\"#$%&()*+,-./:;<=>?@[\\]^_`{|}~");
	}
	initializeDB();
}

void initializeListAfterPrefs(void){
	initializeDBAfterPrefs();
}

Boolean isKanji(UInt8 c){
	return (0x80 <= c && c <= 0x9f) || (0xe0 <= c && c <= 0xff);
}

//static void closeList(void) {
//	//if (gTTP->StnTrains) {
//	//	MemPtrFree(gTTP->StnTrains);
//	//	gTTP->StnTrains = NULL;
//	//}
//	//if (gTTP->StnNameBuf) {
//	//	MemPtrFree(gTTP->StnNameBuf);
//	//	gTTP->StnNameBuf = NULL;
//	//}
//	//if (gTTP->AllTrains) {
//	//	MemPtrFree(gTTP->AllTrains);
//	//	gTTP->AllTrains = NULL;
//	//}
//	//gTTP->Trains = NULL;
//}

//========== Main.c ==============================================================================================
/*static*/ void digit2str(UInt8 x, char *p, Boolean zero) {
	Int16 i;
	if (x > 100) x %= 100;
	i = x/10;
	if (i || zero) {
		*p++ = x/10 + '0';
	} else {
		*p++ = ' ';
	}
	*p++ = x%10 + '0';
	*p = '\0';
}
static Err TimeTableAppInfoInit(DmOpenRef db) {
	UInt16 cardNo;
	MemHandle h;
	LocalID dbID, appInfoID;
	TimeTableAppInfoType *appInfo;
	if(DmOpenDatabaseInfo(db, &dbID, NULL, NULL, &cardNo, NULL))
		return dmErrInvalidParam;
	if(DmDatabaseInfo(cardNo, dbID, NULL, NULL, NULL, NULL, NULL,
										NULL, NULL, &appInfoID, NULL, NULL, NULL))
		return dmErrInvalidParam;
	if(appInfoID == NULL) {
		h = DmNewHandle(db, sizeof(TimeTableAppInfoType));
		if(h == NULL) return dmErrMemError;
		appInfoID = MemHandleToLocalID(h);
		DmSetDatabaseInfo(cardNo, dbID, NULL, NULL, NULL, NULL, NULL,
											NULL, NULL, &appInfoID, NULL, NULL, NULL);
	}
	appInfo = (TimeTableAppInfoType*)MemLocalIDToLockedPtr(appInfoID, cardNo);
	DmSet(appInfo, 0, sizeof(TimeTableAppInfoType), 0);
	CategoryInitialize((AppInfoPtr)appInfo, LocalizedAppInfoStr);
	MemPtrUnlock(appInfo);
	return 0;
}

static void initTTVDB(void){
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	Err err;
	DmOpenRef db = DmOpenDatabaseByTypeCreator('DATA', APPID, dmModeReadOnly);
	if(!db){
		err = DmCreateDatabase(0, "TimeTable Viewer Prefs", APPID, 'DATA', false);
		if(err){
	    //PrivErrSetCode(err);
	    //PrivErrDisplay("Can't create Prefs DB",false);
	    return;
		}
		db = DmOpenDatabaseByTypeCreator('DATA', APPID, dmModeReadWrite);
		if(!db){
	    //PrivErrSetCode(DmGetLastErr());
	    //PrivErrDisplay("Can't open Prefs DB",false);
	    return;
		}
		err = TimeTableAppInfoInit(db);
		if(err){
	    //PrivErrSetCode(err);
	    //PrivErrDisplay("Can't init AppInfo",false);
	    goto error;
		}
	}
	gTTP->TimeTableCategory = CategoryFind(db, "TimeTable");
	gTTP->PrefsCategory = CategoryFind(db, TimeTablePrefsCategoryName);
	if (gTTP->TimeTableCategory == dmAllCategories ||
			gTTP->PrefsCategory     == dmAllCategories   ){
		//PrivErrDisplay("Can't find category",false);
		goto error;
	}
	DmCloseDatabase(db);
	gTTP->TimeTableDB = DmOpenDatabaseByTypeCreator('DATA', APPID, dmModeReadOnly);
	gTTP->TimeTableAppInfoH = getAppInfo(gTTP->TimeTableDB);
	return;
 error:
	DmCloseDatabase(db);
	gTTP->TimeTableDB = NULL;
}

/*static*/ MemHandle getAppInfo(DmOpenRef dbP){
	Err error;
	UInt16 cardNo;
	LocalID dbID;
	LocalID appInfoID;
	error = DmOpenDatabaseInfo(dbP, &dbID, NULL, NULL, &cardNo, NULL);
	if(error){
		//FrmCustomAlert(PrivErrAlert,"Get getting app info block"," "," ");
		return NULL;
	}
	error = DmDatabaseInfo(cardNo,dbID,NULL,NULL,NULL,NULL,NULL,
												 NULL,NULL,&appInfoID,NULL,NULL,NULL);
	if(error){
		//FrmCustomAlert(PrivErrAlert,"Get getting app info block"," "," ");
		return NULL;
	}
	return (MemHandle)MemLocalIDToGlobal(appInfoID, cardNo);
}

/*static*/ void setToday(Boolean manual){
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	//byHAL//DateTimeType dateTime;
	DateTimeType dateTime = gTTP->gHWP->cDateTime; //byHAL
	//byHAL//UInt32       now  = TimGetSeconds();
	UInt32 now = TimDateTimeToSeconds(&(gTTP->gHWP->cDateTime));
	UInt32       diff = now - gTTP->TodaySetSeconds;
	//byHAL//Int16        hour;
	Int16 hour = gTTP->gHWP->cDateTime.hour; //byHAL
	if(diff < 10 * 60) /* 10 min. */
		return;		

	//byHAL//TimSecondsToDateTime(now, &dateTime);
	//byHAL//hour = dateTime.hour;
	if(hour <= MidNight){	/* till 4:00 */
		hour += 24;
		if (dateTime.weekDay == 0) dateTime.weekDay = 6;
		else dateTime.weekDay--;
	}
	if(gTTP->Today == Holiday){
		if((Int32)hour >= (Int32)(diff/(60*60) + MidNight)) 
			return;
	}
	if(dateTime.weekDay == 0) gTTP->Today = Sunday;
	else                      gTTP->Today = (WeekType)(Monday + (dateTime.weekDay - 1));
	if (manual) gTTP->TodaySetSeconds = now;
}

static void loadDefault(void) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	int itr;
	gTTP->ConfigRecordNum = -1;
	gTTP->TrainTimeRecordNum = -1;
	gTTP->LargeClockFlag = true;
	for(itr=0; itr < MENU_NITEMS*2; itr++){
		gTTP->FileMenu[itr].str[0] = '\0';
		gTTP->FileMenu[itr].recordNum = -1;
	}
	gTTP->ShowCommentsFlag = false;
	gTTP->SelLine = gTTP->SelItem = -1;
	gTTP->ManualSelectFlag = false;	/* automatically unselected */
	gTTP->DrawNotesFlag = false;
	gTTP->SelectCurrentFlag = false;
	gTTP->SelectTrain = -1;
	gTTP->prevSelectTrain = -2;
	gTTP->FirstTrain = -1;
	gTTP->LastTrain = -1;
	
	gTTP->HardButtonOverride = 4;		/* 4 sec */
	gTTP->LargeClockFreq = Mostly;
	gTTP->UnderlineSpecialFlag = true;
	gTTP->ScrollByKeyFlag = false;
	gTTP->ShowArrivesFlag = false;
	gTTP->OfsArrive = 0;
	gTTP->NarrowModeDefault = -1;
	gTTP->TwelveFlag = false;
	gTTP->OmitHourFlag = false;
	gTTP->ArrivesColumn = 4;
	gTTP->ArriveTimeHeadType = HeadNone;
	gTTP->StopClockInterval = 1;	/* 3 min */
	gTTP->ChooseStartupFlag = false;
	gTTP->ListOrder = ListOrder_DB_Memo;
	gTTP->InsertPosDB = InsertPosBot;
	gTTP->InsertPosMemo = InsertPosBot;
	gTTP->NLines = -1;
	gTTP->TransNLines = 0;
	gTTP->TodaySetSeconds = 0;
	setToday(false);
	gTTP->ListTop = 0;
	gTTP->StnTop = 0;
	gTTP->SelStn = 0;
	gTTP->StnSepWidth = 0;
	gTTP->MidiIndex = 0;
	gTTP->MinBefore = 3;
	gTTP->BorderMin = -3;	/* no border, both */
	gTTP->HistoryTop = gTTP->HistoryCur = gTTP->HistoryBot = -1; //0;
	for(itr=0; itr < HISTORYMAX; itr++) {
		gTTP->History[itr] = -1;
		gTTP->HisAttr[itr].StopClock = 0;
		gTTP->HisAttr[itr].ManualSelectFlag = false;
		gTTP->HisAttr[itr].SelItem = -1;
		gTTP->HisAttr[itr].SelLine = -1;
	}
	initializeTableDefault();
}

static void loadPrefs(void) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	DmOpenRef prefsDB;
	UInt16 category;
	UInt16 index;
	int itr;
	MemHandle record;
	TimeTableSaveType save;
	TimeTableUnsaveType unsave;
	UInt32 now, timSeconds;

	prefsDB = DmOpenDatabaseByTypeCreator('DATA', APPID, dmModeReadOnly);
	if(!prefsDB) return;
	category = CategoryFind(prefsDB, TimeTablePrefsCategoryName);
	//if(category == dmAllCategories)
	//	PrivErrDisplay("Can't find category. Removed ?",false);

	index = 0;
	record = DmQueryNextInCategory(prefsDB, &index, category);
	if(!record) {
		//PrivErrSetCode(DmGetLastErr());
		//PrivErrDisplay("Can't find save-prefs, Removed ?",false);
		goto close;
	}
	MemMove(&save, MemHandleLock(record), MemHandleSize(record));
	MemHandleUnlock(record);
	switch(save.version) {
    case 8:	gTTP->TwelveFlag         = save.TwelveFlag;
    case 7:	gTTP->NarrowModeDefault  = save.NarrowModeDefault;
    case 6:	for(itr=0; itr < SeparatorMapLen; itr++) gTTP->SeparatorMap[itr] = save.SeparatorMap[itr];
    case 5:	gTTP->BorderMin          = save.BorderMin;
			      for(itr=0; itr < MENU_NITEMS; itr++) gTTP->FileMenu[MENU_NITEMS+itr] = save.FileMenuPM[itr];
    case 4: gTTP->MidiIndex          = save.MidiIndex;
			      gTTP->MinBefore          = save.MinBefore;
    case 3: gTTP->ListOrder          = save.ListOrder;
			      gTTP->InsertPosDB        = save.InsertPosDB;
						gTTP->InsertPosMemo      = save.InsertPosMemo;
    case 2: gTTP->ArriveTimeHeadType = save.ArriveTimeHeadType;
    case 1:	
			for(itr=0; itr < MENU_NITEMS; itr++) 
				gTTP->FileMenu[itr] = save.FileMenu[itr];
			if(save.version <= 4) {
				for (itr=0; itr < MENU_NITEMS; itr++)
					gTTP->FileMenu[MENU_NITEMS+itr] = gTTP->FileMenu[itr];
			}
			gTTP->HardButtonOverride   = save.HardButtonOverride;
			gTTP->StopClockInterval    = save.StopClockInterval;
			gTTP->LargeClockFreq       = save.LargeClockFreq;
			gTTP->ArrivesColumn        = save.ArrivesColumn;
			if(gTTP->ArrivesColumn < 1 || 8 < gTTP->ArrivesColumn) gTTP->ArrivesColumn = 1;
			gTTP->ChooseStartupFlag    = save.ChooseStartupFlag;
			gTTP->UnderlineSpecialFlag = save.UnderlineSpecialFlag;
			gTTP->ScrollByKeyFlag      = save.ScrollByKeyFlag;
			gTTP->OmitHourFlag         = save.OmitHourFlag;
			break;
    default:
			;//PrivErrDisplay("Unknown version of save-prefs, ignored",false);
	}

	index++;
	record = DmQueryNextInCategory(prefsDB, &index, category);
	if(!record) {
		//PrivErrSetCode(DmGetLastErr());
		//PrivErrDisplay("Can't find unsave-prefs, Removed ?",false);
		goto close;
	}
	MemMove(&unsave, MemHandleLock(record), MemHandleSize(record));
	MemHandleUnlock(record);
	if(unsave.version == TimeTableUnsaveVersion) {
		gTTP->SelLine          = unsave.SelLine;
		gTTP->SelItem          = unsave.SelItem;
		gTTP->ManualSelectFlag = unsave.ManualSelectFlag;
		gTTP->OfsArrive        = unsave.OfsArrive;
		//byHAL//gTTP->NLines           = unsave.NLines;
		//BGN:byHAL
		gTTP->NLinesORG        = unsave.NLines;
		gTTP->NLines           = (gTTP->halLayoutID == LO_TableShrink) ? NShrnkdLn : 
			                       (gTTP->halLayoutID == LO_TrainTime  ) ? NTrnTimLn : gTTP->NLinesORG;
		//END:byHAL
		gTTP->SelStn           = unsave.SelStn;
		gTTP->StnSepWidth      = unsave.StnSepWidth;
		gTTP->StnTop           = unsave.StnTop;
		gTTP->ListTop          = unsave.ListTop;
		gTTP->LargeClockFlag   = unsave.LargeClockFlag;
		gTTP->ShowCommentsFlag = unsave.ShowCommentsFlag;
		gTTP->ShowArrivesFlag  = unsave.ShowArrivesFlag;
		timSeconds = unsave.timSeconds;
		gTTP->Today            = unsave.Today;
		gTTP->TodaySetSeconds  = unsave.TodaySetSeconds;
		//byHAL//now = TimGetSeconds();
		now = (gTTP->gHWP) ? TimDateTimeToSeconds(&(gTTP->gHWP->cDateTime)) : TimGetSeconds();
		if(now - timSeconds >= 8 * 60 * 60) gTTP->SelLine = gTTP->SelItem = -1;
		gTTP->ConfigRecordNum    = unsave.ConfigRecordNum;
		gTTP->TrainTimeRecordNum = unsave.TrainTimeRecordNum;
		for(itr=0; itr < HISTORYMAX; itr++) gTTP->History[itr] = unsave.History[itr];
		gTTP->HistoryTop = unsave.HistoryTop;
		gTTP->HistoryCur = unsave.HistoryCur;
		gTTP->HistoryBot = unsave.HistoryBot;
		for(itr=0; itr < HISTORYMAX; itr++) gTTP->HisAttr[itr] = unsave.HisAttr[itr];
		for(itr=0; itr < LRU_MAX   ; itr++) gTTP->LRU[itr]     = unsave.LRU[itr];
		gTTP->LRU_Top = unsave.LRU_Top;
	}
 close:
	DmCloseDatabase(prefsDB);
	//BGN:byHAL //\闚ԍ hwvTimeTable Ǝɒu
	{
		HwvTimeTablePref_t hwvTimeTablePref;
		UInt16 prefSz = sizeof(HwvTimeTablePref_t);
		if(PrefGetAppPreferences(HwvTimeTable_CrtrID, PrefID_HwvTimeTable, &hwvTimeTablePref, &prefSz, IsSavedPref)
			 == HwvTimeTablePrefVerNo){
			//UInt32 tSec = TimGetSeconds();
			if(hwvTimeTablePref.hwvUnsave.version == TimeTableUnsaveVersion &&
				 gTTP->HistoryBot != gTTP->HistoryTop &&
				 (hwvTimeTablePref.hwvUnsave.HistoryCur >  gTTP->HistoryBot || 
				 	hwvTimeTablePref.hwvUnsave.HistoryCur <= gTTP->HistoryTop    ) &&
				 hwvTimeTablePref.hwvUnsave.HistoryCur >= 0          && 
				 hwvTimeTablePref.hwvUnsave.HistoryCur <  HISTORYMAX &&
				 hwvTimeTablePref.orgHistoryCur >= 0 &&
				 gTTP->HistoryCur == hwvTimeTablePref.orgHistoryCur //IWi̗ԍςĂȂus
				 ){
				//WinDrawLine(0, 40, 160, 40);
				//gTTP->HistoryCur = hwvTimeTablePref.hwvHistoryCur;
				////restoreHisAttr(gTTP->HistoryCur);
				////loadTrainTimeDB(gTTP->History[gTTP->HistoryCur]);
				////gTTP->TrainTimeRecordNum = gTTP->History[gTTP->HistoryCur];
				//setTimeTable(gTTP->History[gTTP->HistoryCur]); //->loadTrainTimeDB() -> if(...) restoreHisAttr(gTTP->HistoryCur);
				gTTP->SelLine          = hwvTimeTablePref.hwvUnsave.SelLine;
				gTTP->SelItem          = hwvTimeTablePref.hwvUnsave.SelItem;
				gTTP->ManualSelectFlag = hwvTimeTablePref.hwvUnsave.ManualSelectFlag;
				gTTP->OfsArrive        = hwvTimeTablePref.hwvUnsave.OfsArrive;
				gTTP->NLinesORG        = hwvTimeTablePref.hwvUnsave.NLines;
				gTTP->NLines           = (gTTP->halLayoutID == LO_TableShrink) ? NShrnkdLn : 
					                       (gTTP->halLayoutID == LO_TrainTime  ) ? NTrnTimLn : gTTP->NLinesORG;
				gTTP->SelStn           = hwvTimeTablePref.hwvUnsave.SelStn;
				gTTP->StnSepWidth      = hwvTimeTablePref.hwvUnsave.StnSepWidth;
				gTTP->StnTop           = hwvTimeTablePref.hwvUnsave.StnTop;
				gTTP->ListTop          = hwvTimeTablePref.hwvUnsave.ListTop;
				gTTP->LargeClockFlag   = hwvTimeTablePref.hwvUnsave.LargeClockFlag;
				gTTP->ShowCommentsFlag = hwvTimeTablePref.hwvUnsave.ShowCommentsFlag;
				gTTP->ShowArrivesFlag  = hwvTimeTablePref.hwvUnsave.ShowArrivesFlag;
				timSeconds = hwvTimeTablePref.hwvUnsave.timSeconds;
				gTTP->Today            = hwvTimeTablePref.hwvUnsave.Today;
				gTTP->TodaySetSeconds  = hwvTimeTablePref.hwvUnsave.TodaySetSeconds;
				now = (gTTP->gHWP) ? TimDateTimeToSeconds(&(gTTP->gHWP->cDateTime)) : TimGetSeconds();
				if(now - timSeconds >= 8 * 60 * 60) gTTP->SelLine = gTTP->SelItem = -1;
				gTTP->ConfigRecordNum    = hwvTimeTablePref.hwvUnsave.ConfigRecordNum;
				gTTP->TrainTimeRecordNum = hwvTimeTablePref.hwvUnsave.TrainTimeRecordNum;
				for(itr=0; itr < HISTORYMAX; itr++) gTTP->History[itr] = hwvTimeTablePref.hwvUnsave.History[itr];
				gTTP->HistoryTop = hwvTimeTablePref.hwvUnsave.HistoryTop;
				gTTP->HistoryCur = hwvTimeTablePref.hwvUnsave.HistoryCur;
				gTTP->HistoryBot = hwvTimeTablePref.hwvUnsave.HistoryBot;
				for(itr=0; itr < HISTORYMAX; itr++) gTTP->HisAttr[itr] = hwvTimeTablePref.hwvUnsave.HisAttr[itr];
				for(itr=0; itr < LRU_MAX   ; itr++) gTTP->LRU[itr]     = hwvTimeTablePref.hwvUnsave.LRU[itr];
				gTTP->LRU_Top = hwvTimeTablePref.hwvUnsave.LRU_Top;
			}else{                                                      //ԍςĂ΋L^ĂBu͂Ȃ
				//WinDrawLine(0, 120, 160, 120);
				hwvTimeTablePref.orgHistoryCur = -1;
				if(unsave.version == TimeTableUnsaveVersion){
					hwvTimeTablePref.orgHistoryCur = unsave.HistoryCur; //gTTP->HistoryCur;
					hwvTimeTablePref.hwvUnsave     = unsave;
				}
				PrefSetAppPreferences(HwvTimeTable_CrtrID, PrefID_HwvTimeTable, HwvTimeTablePrefVerNo, &hwvTimeTablePref, prefSz, IsSavedPref);
			}
			//do{ ; }while(tSec + 10 > TimGetSeconds());
		}
	}
	//END:byHAL
}

//void init_TimeTable_Params(void){
//	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
//	//>Main.c:PilotMain():cmd==sysAppLaunchCmdNormalLaunch
//	//>>StartApplication();
//	//>>>initialize();
//	gTTP->PrivErrExtraStr = NULL;
//	gTTP->LastSec = 0;           
//	initializeTable();           //>>>>Table.c>initializeTable();
//	initializeList();            //>>>>List.c>initializeList();
//	loadDefault();               //>>>>Main.c>loadDefault(); 
//	loadPrefs();                 //>>>>Main.c>loadPrefs();
//	initializeTableAfterPrefs(); //>>>>Table.c>initializeTableAfterPrefs();
//	initializeListAfterPrefs();  //>>>>List.c>initializeListAfterPrefs();
//	initTTVDB();                 //>>>>Main.c>initTTVDB();
//}
//void draw_TimeTable(void){
//	//>Main.c:PilotMain():cmd==sysAppLaunchCmdNormalLaunch
//	//>>FrmGotoForm(MainForm); //>>EventLoop(); -> MainFormHandleEvent(EventPtr e);
//	//--- FOLLOW HERE 060216 ---
//	frmOpenEvent_MainFormHandleEvent(); //Table.c>MainFormHandleEvent()>case frmOpenEvent:
//}
//void close_TimeTable_Params(void){
//	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
//	//>Main.c:PilotMain():cmd==sysAppLaunchCmdNormalLaunch
//	//>>StopApplication();
//	//>>>terminateTableBeforePrefs();
//	//>>>savePrefs();
//	//>>>terminateTable();
//	//closeTable();
//	//>>>terminateList();
//	//closeList();
//	//DmCloseDatabase(gTTP->MemoDB);
//	//if(gTTP->TimeTableDB) DmCloseDatabase(gTTP->TimeTableDB);
//}

//========== vʕ` ========================================================================================
UInt32 myMain(UInt16 cmd, HalWatchGlobals_t *gP){
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();

	//----- I
	if(cmd == HalWatchLaunchCmdFinalize || gP == NULL){
		if(gTTP != NULL) 
			freePtrTimeTableGlobals(gTTP);
		return errNone;
	}

	//----- ڂ̋N
	if(gTTP->gHWP == NULL && !gTTP->isNoData){
		gTTP->gHWP = gP;
		WinEraseWindow();
		gTTP->PrivErrExtraStr = NULL;
		gTTP->LastSec = 0;           
		initializeTable();           //>>>>Table.c>initializeTable();
		initializeList();            //>>>>List.c>initializeList();
		loadDefault();               //>>>>Main.c>loadDefault(); 
		loadPrefs();                 //>>>>Main.c>loadPrefs();
		//if(gTTP->HistoryTop >= 0 && gTTP->HistoryBot >= 0 && gTTP->HistoryCur >= 0){
		initializeTableAfterPrefs(); //>>>>Table.c>initializeTableAfterPrefs();
		initializeListAfterPrefs();  //>>>>List.c>initializeListAfterPrefs();
		initTTVDB();                 //>>>>Main.c>initTTVDB();
		if(frmOpenEvent_MainFormHandleEvent()) //draw_TimeTable(); // drawTable() is executed at here
			return HalWatchReturnCodeRequestFinalize;
		//if false, frmOpenEvent_MainFormHandleEvent() set gTTP->isNoData = true
		gTTP->isNoData = true;
		//if(gTTP->isNoData){
		//	menuEvent_FileMenuOneToEight_MainFormHandleEvent(true);
		//	gTTP->isNoData = (gTTP->cFileMenuItemID < 1 || gTTP->cFileMenuItemID > MENU_NITEMS);
		//}
		//}
	}

	gTTP->gHWP = gP;

	//----- G[\ see frmOpenEvent_MainFormHandleEvent()
	if(gTTP->isNoData){
		Char   cStr[32];
		UInt16 cStrLen;
		FontID orgFontID = FntSetFont(FossilLargeFont);

		StrPrintF(cStr, "hwvTimeTable : Error"); cStrLen = StrLen(cStr);
		WinDrawChars(cStr, cStrLen, 80-FntCharsWidth(cStr, cStrLen)/2,  40-FntCharHeight()/2);
		StrPrintF(cStr, "No History"); cStrLen = StrLen(cStr);
		WinDrawChars(cStr, cStrLen, 80-FntCharsWidth(cStr, cStrLen)/2,  70-FntCharHeight()/2);
		StrPrintF(cStr, "  %d : %02d  ", gP->cDateTime.hour, gP->cDateTime.minute);	cStrLen = StrLen(cStr);
		WinDrawChars(cStr, cStrLen, 80-FntCharsWidth(cStr, cStrLen)/2, 125-FntCharHeight()/2);

		FntSetFont(orgFontID);
		return HalWatchReturnCodeRequestFinalize;
	}

	//----- ύX
	switch(gTTP->gHWP->customCmdID){
		case CustomCmdID_RockerUp:   //\-ǂ
			ctlSelectEvent_MainForwardBackward_MainFormHandleEvent(true);
			gTTP->gHWP->redrawLevel = RL_All;
			//return HalWatchReturnCodeRequestFinalize;
			break;

		case CustomCmdID_RockerDown: //\-
			ctlSelectEvent_MainForwardBackward_MainFormHandleEvent(false);
			gTTP->gHWP->redrawLevel = RL_All;
			//return HalWatchReturnCodeRequestFinalize;
			break;

		case CustomCmdID1:            //\-ǂ
			menuEvent_FileMenuOneToEight_MainFormHandleEvent(true);
 			gTTP->gHWP->redrawLevel = RL_All;
			//return HalWatchReturnCodeRequestFinalize; 
			break;

		case CustomCmdID2:            //\-
			menuEvent_FileMenuOneToEight_MainFormHandleEvent(false);
 			gTTP->gHWP->redrawLevel = RL_All;
			//return HalWatchReturnCodeRequestFinalize; 
			break;

		case CustomCmdID3:           //CAEg؂ւ
			switch(gTTP->halLayoutID){
				case LO_Org        : gTTP->halLayoutID = LO_TableShrink; break;
				case LO_TableShrink: gTTP->halLayoutID = LO_TrainTime  ; break;
				case LO_TrainTime  :
				default            : gTTP->halLayoutID = LO_Org        ; break;
			}
			setTimeTable(gTTP->TrainTimeRecordNum); //->loadTrainTimeDB()->set value gTTP->NLines based on gTTP->halLayoutID
			gTTP->gHWP->redrawLevel = RL_All;
			break;

		case CustomCmdID4:           //l胂[hؑ
			//gTTP->isNarrowModeInvert = !(gTTP->isNarrowModeInvert);
			menuEvent_OptionsMenuNarrow_MainFormHandleEvent(); 
			gTTP->gHWP->redrawLevel = RL_All;
			break;

		default:
			break;
	}

	//----- PXV
	switch(gTTP->gHWP->redrawLevel){
		default:
			WinEraseWindow();
			drawTable(); // drawTime() ͂̓ŎsB
			break;       // drawTime() ̘As͕s炷Hxqx

		case RL_Min: //Table.c:MainFormHandleEvent():switch(e->eType){case nilEvent
			drawTime(false);
			if(gTTP->DrawNotesFlag) // ԂXVꂽꍇɃRgGA̕\XV
				drawTime(true); 
			drawBatt();
			break;
	}

	//----- 
	return HalWatchReturnCodeRequestFinalize;
}

//========== PDA [h̏ ====================================================================================
//void waitAppClose(void){
//	EventType event;
//	do{
//		EvtGetEvent(&event, evtWaitForever);
//		switch(event.eType){
//			case keyDownEvent: if(event.data.keyDown.chr != vchrThumbWheelPush) break;
//			case penDownEvent: event.eType = appStopEvent;
//			default: break;
//		}
//		if(SysHandleEvent(&event)) continue;
//		if(FrmDispatchEvent(&event)) continue;
//	}while(event.eType != appStopEvent);        // AvICxg烋[v𔲂ďI
//}

//================================================================================================================
UInt32 PilotMain(UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags){
	TimeTableGlobals_t* gTTP = NULL;
	UInt32 ret = errNone;

	switch(cmd){
		case wpdaAppLaunchWatchFaceNext: // WristPDA v[h
		case wpdaAppLaunchWatchFacePrev: // WristPDA v[h
		case wpdaAppLaunchWatchDrawTime: // WristPDA v[h
			//return DAMain(cmd, (HalWatchGlobals_t*)cmdPBP);
			{
#if UseStackReplace	
				long  orgStack;
				void *newStack = (void *)MemPtrNew(STACKSZ); // X^bN̏
				if(newStack != NULL){ 
#endif
#if UseGlobalReplace               //Globalϐޔ
					SAVE_A4_REGISTER
#endif			
#if UseStackReplace	
					orgStack = __getA7();
					__setA7((long) newStack + STACKSZ);        // X^bNu
#endif
					
					ret = myMain(cmd, (HalWatchGlobals_t*)cmdPBP);
					
#if UseStackReplace	
					__setA7(orgStack);                         // X^bN߂
					MemPtrFree((void *)newStack);
#endif
#if UseGlobalReplace               //Globalϐ߂
					RESTORE_A4_REGISTER
#endif
#if UseStackReplace
				}
#endif
			}
			return ret;

		case HalWatchLaunchCmdFinalize : // HalWatch IĂяo
			if(FtrGet(HwvTimeTable_CrtrID, FtrID_TimeTableGlobals, (UInt32*)&gTTP) //tB[`̎擾݂
				 == 0 && gTTP != NULL){                                              // ݒς݂Ȃ
				freePtrTimeTableGlobals(gTTP);                                       //  J
			}
			return errNone;
			
		case sysAppLaunchCmdNormalLaunch: // PDA Mode ʏN
			break;

		default: 
			break;
	}

	return errNone;
}
