// hwvTimeTable.h Time-stamp: <2006/03/24 21:44 haru@XP4PDA05C>
// (C) 2005-2006 HAL <http://hal9.blog3.fc2.com> HAL.Kinosita@gmail.com

/*
 * TimeTable Viewer
 * Copyright(c)1999 by Hiroaki Sengoku <sengoku@gcd.org>
 * Version 0.1	Jun 19, 1999
 * Version 0.2	Jun 20, 1999
 * Version 0.3	Jun 20, 1999
 * Version 0.4	Jun 21, 1999
 * Version 0.5	Jun 22, 1999	AboutDialog
 * Version 0.6	Jun 25, 1999	SelectTrain, HardButton, PrefsDialog
 * Version 0.7	Jun 26, 1999	scroll bug fix
 * Version 0.8	Jul  3, 1999	Arrive, ShareReg, History, Transfer, StopClock
 * Version 0.9	Jul  8,	1999	multi '>', ContFile, CommentMark, scramble
 * Version 1.0	Jul 31, 1999	split bar, DB, ;;CANCEL, '\' esc, HeadType, LRU
 * Version 1.1	Aug 26, 1999	checkTimeOut
 * Version 1.2	Aug 27, 2000	Alarm, InstalledSec, LastUsedSec
 * Version 1.3  Aug  1, 2001	GPL version
 */

#ifndef __HwvTimeTable_H__
#define __HwvTimeTable_H__

#include <PalmOS.h>
#include <StdIOPalm.h>

#include <WristPDA.h>
#include "../HalWatch.h"

//#define DEBUGLINE 1

//#define MAIN_SECTION 
//#define TABLE_SECTION __attribute__ ((section ("tbls"))) // for multisegment
#define TABLE_SECTION                                    // normal build

//CAEg
#define XPosLeft     0
#define XPosRight  159
#define YPosTop      0
#define YPosBottom 159

//Rsc.ja.rcp
#define TimeTablePos_X0    0
#define TimeTablePos_Y0   16 //14 //30
#define TimeTablePos_Wid 140
#define TimeTablePos_Hgt  87 
#define MainScrollBar_X0  153 //153
#define MainScrollBar_Y0   15 //31
#define MainScrollBar_Wid   4 //7
#define MainScrollBar_Hgt  83

//========== Makefile ============================================================================================
#define APPID 'GCDt'

//========== Rsc.h ===============================================================================================
#define SeparatorStr			1372
#define STRMAX				100
#define LocalizedAppInfoStr		1000
#define BitmapZero			2000
#define BitmapAlarm			2030

//========== Common.h ============================================================================================
#define SeparatorMapLen	12
#define MidNight	3	/* 3:00 am */
#define HISTORYMAX	20
#define LRU_MAX		40
#define MENU_LEN_MAX	40
#define MENU_NITEMS	8
#define STRLINEMAX	500
#define NarrowsOffset	2	/* all, w/o notes */
#define ExCommentsMax	600
#define NoComment	52
#define AlarmMinuteMax	(19*60)		/* 19 hours */

typedef struct item {
    UInt8 minute ; /* 0-59 */
    Int8  comment; /* -1, 0-51, 52 */
    UInt8 mark   ; /* comment mark */
} ItemType;

typedef struct line {	/* NEVER contain Word alignment */
    Int8     hour     ;
    Int8     length   ; /* at most 60 (< 128) */
    UInt8    excom_msb; /* length of extra comments (MSB) */
    UInt8    excom_lsb; /* length of extra comments (LSB) */
    ItemType items[0] ; /* variable length */
} LineType;

typedef struct timetable {
    Int32      recordNum  ;
    LineType **Lines      ;
    Int16      LinesLen   ;
    UInt8     *LinesBuf   ;
    Char     **Comments   ;
    Char      *CommentsBuf;
    Char     **Arrives    ;
    Int16      ArrivesLen ;
    Char      *ArrivesBuf ;
    Int16      NarrowsLen ;
    Char     **Narrows    ;
} TimeTableType;

typedef struct {
	Int16 itop;
	Int16 ilen;
	Char *name;
} StnIndexType;

typedef struct {
	UInt32  StopClock       ;
	Boolean ManualSelectFlag;
	Int16   SelItem         ;
	Int16   SelLine         ;
} HisAttrType;

typedef struct {
	Int16 next;
	Int32 recordNum;
	Int16 OfsArrive;
	Int16 NarrowMode;
	Int16 NLines;
	Boolean ShowArrivesFlag;
} LRU_Type;

typedef struct {
	Char str[MENU_LEN_MAX];
	Int32 recordNum;
} FileMenuType;

typedef struct {	/* ver >= 12 */
	UInt16 renamedCategories;
	Char categoryLabels[dmRecNumCategories][dmCategoryLength];
	UInt8 categoryUniqIDs[dmRecNumCategories];
	UInt8 lastUniqID;
	UInt8 reserved0;
	UInt16 reserved1;
	UInt16 reserved2;
	UInt8 sortOrder;
	UInt8 reserved3;
	UInt16 reserved4;
	UInt32 alarmRecID;
	LocalID alarmDbID;
	UInt16 alarmCardNo;
} TimeTableAppInfoType;

typedef enum { InsertPosAlphabetical, InsertPosTop, InsertPosBot } InsertPosType;
typedef enum { Never, Rarely, Normal, Mostly, Always} FreqType;
typedef enum { HeadNone, HeadDepTime, HeadNote, HeadTimeNote } HeadType;
typedef enum { ListOrder_DB_Memo, ListOrder_Memo_DB, ListOrder_Mix, ListOrder_DB_Only, ListOrder_Memo_Only } ListOrderType;
typedef enum {Errday=-1, Allday, Weekday,
							Monday, Tuesday, Wednesday, Thursday, Friday,
							Saturday, Sunday, Holiday,
							User0, User1, User2, User3, User4,
							User5, User6, User7, User8, User9,
} WeekType;
typedef enum { privErrNone, privErrNotEnoughSpace, privErrCanNotHappen } PrivErrType;
typedef enum { InvertMark, UnMark,	SuccMark, PrecMark, MiddleMark, Mark, DotMark, DDotMark,
							 CancelMark,	Mark00000, Mark11111=Mark00000+0x1F
} CommentMarkType;

//========== DB.c ================================================================================================
#define NComments	(26*2+1)
#define TimeTableRecordNumMin	0x10000L

typedef struct {
	UInt16 renamedCategories;
	Char   categoryLabels[dmRecNumCategories][dmCategoryLength];
	UInt8  categoryUniqIDs[dmRecNumCategories];
	UInt8  lastUniqID;
	UInt8  reserved1;
  UInt16 reserved2;
  UInt16 reserved3;
	UInt8  sortOrder;
} MemoAppInfoType;

//========== Table.c =============================================================================================
#define NNumBitmaps	12
#define SpaceWidth	3
#define ScreenX		160
#define ScreenY		160
#define NumBitmapX	24
#define NumBitmapY	39
#define ColonBitmapX	11
#define LargeClockX	(ScreenX-NumBitmapX*4-ColonBitmapX)
#define LargeClockY	(ScreenY-NumBitmapY)
#define AlarmSize	13
#define ArrivesColumnMax	10
#define LargeClockMin	(-10*60)

//========== Dialog.c ============================================================================================
Int16 getAlarm(void) ;//MAIN_SECTION;
void setSeparator(UInt8 *p) ;//MAIN_SECTION;

//========== DB.c ================================================================================================
void initializeDB(void) ;//MAIN_SECTION;
#ifdef HwvTimeTable_DB
static Int16 isConfigFile(UInt16 recordNum) ;//MAIN_SECTION;
static void configFile(void) ;//MAIN_SECTION;
#endif
void initializeDBAfterPrefs(void) ;//MAIN_SECTION;
TimeTableType *newTimeTable(void) ;//MAIN_SECTION;
void disposeTimeTable(TimeTableType *table) ;//MAIN_SECTION;
void skipSpace(Char **pp) ;//MAIN_SECTION;
#ifdef HwvTimeTable_DB
static void skipLine(Char **pp) ;//MAIN_SECTION;
static Int8 conv2digit(Char **pp) ;//MAIN_SECTION;
static Int16 dateToken(Char **pp) ;//MAIN_SECTION;
static WeekType weekTypeToken(Char **pp) ;//MAIN_SECTION;
static WeekType parseConfig(MemHandle h) ;//MAIN_SECTION;
static Int16 convDigits(Char **pp) ;//MAIN_SECTION;
#endif
Int16 getLine(Char **pp) ;//MAIN_SECTION;
Boolean isContFile(Char **pp) ;//MAIN_SECTION;
#ifdef HwvTimeTable_DB
static Char contNextChar(Char **pp) ;//MAIN_SECTION;
#endif
void titleLine(Char **pp) ;//MAIN_SECTION;
#ifdef HwvTimeTable_DB
static Boolean weekTypeLine(Char **pp) ;//MAIN_SECTION;
static Int32 btoi(Char **pp) ;//MAIN_SECTION;
static void directiveLine(Char **pp) ;//MAIN_SECTION;
static Int16 commentChar(Char c) ;//MAIN_SECTION;
static Int16 commentLine(Char **pp, Char *buf, Char **comments, CommentMarkType *commentsMark, Char **narrows, Int16 *narrowsLenP) ;//MAIN_SECTION;
static Boolean ishidden(Int8 com, Int8 *comments) ;//MAIN_SECTION;
static Boolean convItem(Char **pp, ItemType *item, Int8 *comments, Int16 *cip, CommentMarkType *commentsMark) ;//MAIN_SECTION;
static void storeWord(UInt16 w, UInt8 *p) ;//MAIN_SECTION;
static Int16 convLine(Char **pp, LineType *line, Int16 *cip, CommentMarkType *commentsMark) ;//MAIN_SECTION;
static Int16 hourLine(Char **pp, LineType *line, LineType **lines, Int16 *lenP, CommentMarkType *commentsMark) ;//MAIN_SECTION;
static Int16 arriveLine(Char **pp, Char *buf, Char **arrives, Int16 *lenP) ;//MAIN_SECTION;
static void passDB(Int32 recordNum, TimeTableType *table, Int16 *tlenp, Int16 *clenp, Int16 *alenp, CommentMarkType *commentsMark) ;//MAIN_SECTION;
static PrivErrType convTrainTimeDB(Int32 recordNum, TimeTableType *table) ;//MAIN_SECTION;
#endif
/*static*/ Boolean loadDB(Int32 recordNum) ;//MAIN_SECTION;
Boolean checkTitle(Int32 recordNum, Char *title) ;//MAIN_SECTION;
Int32 searchFile(Char *p) ;//MAIN_SECTION;

//========== Table.c =============================================================================================
extern void initializeTable(void) TABLE_SECTION;
#ifdef HwvTimeTable_Table
static void initLRU(void) TABLE_SECTION;
#endif
extern void initializeTableDefault(void) TABLE_SECTION;
extern void initializeTableAfterPrefs(void) TABLE_SECTION;
//extern void closeTable(void) TABLE_SECTION;
#ifdef HwvTimeTable_Table
static void openTable(void) TABLE_SECTION;
static Boolean getLRU(Int32 record) TABLE_SECTION;
static void putLRU(void) TABLE_SECTION;
static void setFirstLastTrain(void) TABLE_SECTION;
//static Boolean loadTrainTimeDB(Int32 recordNum) TABLE_SECTION;
#endif
extern Boolean loadTrainTimeDB(Int32 recordNum) TABLE_SECTION;
#ifdef HwvTimeTable_Table
static UInt16 getUInt16(UInt8 *p) TABLE_SECTION;
static Boolean getComments(TimeTableType *table, Int16 item, Int16 line, Int8 *comments) TABLE_SECTION;
static void drawComment(Int8 *coms, Int16 width, Int16 x, Int16 y) TABLE_SECTION;
static Boolean commentMatch(Int8 **pp, Int8 *coms) TABLE_SECTION;
static Int16 timeRequired(TimeTableType *table, Int16 stn, Int8 *coms) TABLE_SECTION;
static void loadArrives(TimeTableType *table,	Int16 column, Int16 minute, Int8 *coms) TABLE_SECTION;
static Boolean nextTrain(Int16 *itemP, Int16 *lineP) TABLE_SECTION;
static Boolean isLargeClockShown() TABLE_SECTION;
static Char *transFile(Int16 n) TABLE_SECTION;
static Boolean isTransfer(Int16 n) TABLE_SECTION;
static void drawArrive(Int16 n) TABLE_SECTION;
static void drawArrives(void) TABLE_SECTION;
//static void drawLowerSplit(Boolean draw) TABLE_SECTION;
static void showComment(Int16 n, Char *time, Int8 *coms, Boolean flag) TABLE_SECTION;
static void showCommentLine(Int16 n) TABLE_SECTION;
static void showComments(void) TABLE_SECTION;
static void selectItem(Int16 item, Int16 line, Boolean draw) TABLE_SECTION;	
static void unselectItem(void) TABLE_SECTION;
//static void restoreHisAttr(Int16 pos) TABLE_SECTION;
#endif
extern void restoreHisAttr(Int16 pos) TABLE_SECTION;
#ifdef HwvTimeTable_Table
static Int32 backHistory(void) TABLE_SECTION;
static Int32 forwardHistory(void) TABLE_SECTION;
//static Int16 pushHistory(Int32 record, Int16 ins) TABLE_SECTION;
//static void storeHistory(Int32 record) TABLE_SECTION;
#endif
extern Boolean setTimeTable(Int32 recordNum) TABLE_SECTION;
#ifdef HwvTimeTable_Table
static Int16 xy2train(Int16 x, Int16 y, Boolean xyFlag) TABLE_SECTION;
static Int16 minute2nextTrain(Int16 minute, Int16 *itemP, Int16 *lineP) TABLE_SECTION;
static void setNextTrain(Int16 *itemP, Int16 *lineP) TABLE_SECTION;
static void invertXY(Int16 x, Int16 y, CommentMarkType type) TABLE_SECTION;	/* [pixel] */
static void invertItem(Int16 item, Int16 line, CommentMarkType type, Boolean offs) TABLE_SECTION;
static void drawTableLine(Int16 i) TABLE_SECTION;
//static void updateTableBar(Boolean draw) TABLE_SECTION;
static void scrollTable(Int16 lines) TABLE_SECTION;
static void focusItem(Int16 line, Boolean draw) TABLE_SECTION;
static void selectCurrent(Boolean notes, Boolean draw) TABLE_SECTION;
//#endif
//extern void selectCurrent(Boolean notes, Boolean draw) TABLE_SECTION;
//#ifdef HwvTimeTable_Table
static void drawAlarm(void) TABLE_SECTION;
static void drawBitmap(Int16 num, Int16 x, Int16 y) TABLE_SECTION;
//static Boolean drawLargeClock(Int16 min, Int16 sec) TABLE_SECTION;
static Boolean drawLargeClock(Int16 min, Boolean minus) TABLE_SECTION;
static void drawTrainTimeClock(Int16 min, Boolean minus) TABLE_SECTION;
//static void drawTime(Boolean draw) TABLE_SECTION;
#endif
extern void drawTime(Boolean draw) TABLE_SECTION;
extern void drawBatt(void)  TABLE_SECTION;
#ifdef HwvTimeTable_Table
static void drawTableLine(Int16 i) TABLE_SECTION;
static void drawTableTime(void) TABLE_SECTION;
//static void drawTable(void) TABLE_SECTION;
static FileMenuType *getFileMenuItem(Int16 item) TABLE_SECTION;
#endif
extern void drawTable(void) TABLE_SECTION;
extern Boolean frmOpenEvent_MainFormHandleEvent(void) TABLE_SECTION; 
extern void ctlSelectEvent_MainForwardBackward_MainFormHandleEvent(Boolean isBackward) TABLE_SECTION;
extern void menuEvent_FileMenuOneToEight_MainFormHandleEvent(Boolean isBackward) TABLE_SECTION;
extern void menuEvent_OptionsMenuNarrow_MainFormHandleEvent(void) TABLE_SECTION; 

//========== List.c ==============================================================================================
void initializeList(void) ;//MAIN_SECTION;
void initializeListAfterPrefs(void) ;//MAIN_SECTION;
Boolean isKanji(UInt8 c) ;//MAIN_SECTION;

//========== Main.c ==============================================================================================
#define TimeTablePrefsCategoryName	"Prefs"
#define TimeTableSaveVersion    8 /* < TimeTableUnsaveVersion */
#define TimeTableUnsaveVersion 17 /* > TimeTableSaveVersion   */

#define HOUR(h, flag)	(((flag) && (h) > 12) ? ((h)-1) % 12 + 1 : (h))

typedef struct {
	Int16 version;		/* big endian is assumed */
	Int16 HardButtonOverride;			/* save_ver >= 1 */
	Int16 StopClockInterval;
	Int16 ArrivesColumn;
	FreqType LargeClockFreq;
	Boolean ChooseStartupFlag;
	Boolean UnderlineSpecialFlag;
	Boolean ScrollByKeyFlag;
	Boolean OmitHourFlag;
	Boolean obsolete_1;
	Char obsolete_2[STRMAX+1];
	FileMenuType FileMenu[MENU_NITEMS];		/* save_ver >= 2 */
	HeadType ArriveTimeHeadType;
	ListOrderType ListOrder;			/* save_ver >= 3 */
	InsertPosType InsertPosDB;
	InsertPosType InsertPosMemo;
	UInt16 MidiIndex;				/* save_ver >= 4 */
	Int16 MinBefore;
	Int16 BorderMin;				/* save_ver >= 5 */
	FileMenuType FileMenuPM[MENU_NITEMS];
	UInt8 SeparatorMap[SeparatorMapLen];		/* save_ver >= 6 */
	Int16 NarrowModeDefault;			/* save_ver >= 7 */
	Boolean TwelveFlag;				/* save_ver >= 8 */
} TimeTableSaveType;

typedef struct {
	Int16 version;		/* big endian is assumed */
	Int16 SelLine;
	Int16 SelItem;
	Int16 OfsArrive;
	Int16 NLines;
	Int16 SelStn;
	Int16 StnTop;
	Int16 StnSepWidth;
	Int16 ListTop;
	Boolean ManualSelectFlag;
	Boolean LargeClockFlag;
	Boolean ShowCommentsFlag;
	Boolean ShowArrivesFlag;
	WeekType Today;
	UInt32 TodaySetSeconds;
	UInt32 timSeconds;
	Int32 ConfigRecordNum;
	Int32 TrainTimeRecordNum;
	Int32 History[HISTORYMAX];
	Int16 HistoryTop;
	Int16 HistoryCur;
	Int16 HistoryBot;
	HisAttrType HisAttr[HISTORYMAX];
	Int16 LRU_Top;
	LRU_Type LRU[LRU_MAX];
} TimeTableUnsaveType;

//========== hwvTimeTable Ǝۑ̂߂ preference ̊Ǘ =================================================
#define HwvTimeTablePrefVerNo 1
#define IsSavedPref 0
#define PrefID_HwvTimeTable 0

#define NShrnkdLn 3 //\̍s for LO_TableShrink
#define NTrnTimLn 4 //\̍s for LO_TrainTime

typedef enum { LO_Org=0, LO_TableShrink=1, LO_TrainTime=2 } HalLayout_t;

typedef struct {
	HalLayout_t         layoutID;
	Int16               cFileMenuItemID;
	Int16               orgHistoryCur;
	//Int16               hwvHistoryCur;
	TimeTableUnsaveType hwvUnsave;
} HwvTimeTablePref_t;

//========== Ftr ̊Ǘ ==========================================================================================

#define FtrID_TimeTableGlobals 17

typedef struct {
#ifdef DEBUGLINE
	UInt16 cDbgLnNo;
	UInt16 cDbgCmtNo;
#endif
	HalWatchGlobals_t *gHWP; //HalWatchn
	Boolean isNoData;
	HalLayout_t halLayoutID; //hwvTimeTableƎ̃CAEghc
	Boolean isNarrowModeInvert;
	Int16  cFileMenuItemID; // 1-8 ̃V[gJbgŎ\Ăяo@\𗘗p

	FontID font4table;      //㔼̃e[up̃tHg
	FontID font4Note;       //̗ԂƂ̏ڍחptHg
	FontID fontB4Note;      //ڍו\ɎgtHg
	FontID font4NoteTop;    //ڍו\̐擪i攭ԁjp̃tHg
	//FontID font4CTime;      //ݎ̃tHg
	FontID font4Title;      //\^CgtHg
	//Boolean isShrinkTable;

	//>>Main.c
	Char      *PrivErrExtraStr;
	UInt32     LastSec        ;
	//MenuBarPtr CurrentMenuBar;
	UInt16 PrefsCategory;

	//>>Table.c
	TimeTableType *CurrentTable;
	Int16         *ArriveTime;
	Int16          ArriveTimeHead[ArrivesColumnMax];
	UInt8          ArriveTimeHeadMark[ArrivesColumnMax];
	Int16          NextTrain;
	UInt16         TicksPerSeconds;
	MemHandle      NumBitmap[NNumBitmaps];
	MemHandle      AlarmBitmap;
	Boolean        StartupFlag;
	//FormPtr        MainFormPtr;
	Boolean        AlarmDialogFlag;
	Int16          AlarmMinute;
	Int16          AlarmMinuteSave;
	Int16          AlarmTapCount;
	//Char         **NarrowOrgItemsText;
	Int32          ConfigRecordNum;
	Int32          TrainTimeRecordNum;
	Boolean        LargeClockFlag;
	Int8           CommentsTmp[ExCommentsMax];
	Boolean        ShowCommentsFlag;
	Int16          SelLine;
	Int16          SelItem;
	Boolean        ManualSelectFlag;
	Boolean DrawNotesFlag;
	Boolean SelectCurrentFlag;
	Int16 SelectTrain;
	Int16 prevSelectTrain; //byHAL
	Int16 FirstTrain;
	Int16 LastTrain;
	Int16          HardButtonOverride;
	FreqType       LargeClockFreq;
	FileMenuType FileMenu[MENU_NITEMS*2];
	Boolean        UnderlineSpecialFlag;
	Boolean        ScrollByKeyFlag;
	Boolean        ShowArrivesFlag;
	Boolean        ArriveBarFlag;
	Int16          ArriveRightX;
	Int16          OfsArrive;
	Int16          NarrowMode;
	Int16          NarrowModeORG; //byHAL
	Int16          NarrowModeDefault;
	Boolean        TwelveFlag;
	Boolean        OmitHourFlag;
	Int16          ArrivesColumn;
	HeadType       ArriveTimeHeadType;
	Int16          StopClockInterval;
	Boolean        ChooseStartupFlag;
	Int16          TransNLines;
	Int16          BorderMin;	/* -3:Both, -2:PM, -1:AM, 0-:minute */
	Int16          HistoryTop;
	Int16          HistoryCur;
	Int16          HistoryBot;
	Int32          History[HISTORYMAX];
	HisAttrType    HisAttr[HISTORYMAX];
	LRU_Type       LRU[LRU_MAX];
	Int16          LRU_Top;
	//MenuBarPtr     MainMenuBar;
	WinHandle      OffScreen;
	UInt16         OffScreenErr;
	//MemHandle      MoveMenuItemStrH;
	Int16 ItemWidth;	/* [pixel] */
	Int16 ItemHeight;
	Int16 TableX;	/* [pixel] */
	Int16 TableY;
	Int16 TopY;
	Int16 NItems;	/* [cell] */
	Int16 NLines;
	Int16 NLinesORG; //byHAL
	Int16 TimeWidth;
	Int16 TimeHeight;
	Int16 TimeX;
	Int16 TimeY;
	Int16 TimeLeftX;
	Int16 TimeLeftColonX;
	Int16 BoldColonWidth;
	RectangleType NormalClockRect;
	RectangleType AlarmRect;
	Int16 StnX;
	Int16 StnXLower;
	Int16 StnExtent;
	//MemHandle NumBitmap[NNumBitmaps];
	Boolean ClockInvertedFlag;
	UInt32 StopClock;
	//DmOpenRef OrgAppDbRef;
	Int16 OfsItem;
	Int16 OfsLine;
	Int16 NarrowEndX;
	//>>Table.c

	//>>List.c
	//StnIndexType *StnTrains;
	Char         *StnNameBuf;
	Int32        *AllTrains;
	Int32        *Trains;
	//FormPtr       ListFormPtr;
	//MenuBarPtr    ListMenuBar;
	ListOrderType ListOrder;
	Int16         ListTop;
	Int16         StnTop;
	Int16         SelStn;
	Int16         StnSepWidth;

	//>>DB.c
	DmOpenRef     TimeTableDB;
	DmOpenRef     MemoDB;
	UInt16        TrainTimeCategory;
	InsertPosType InsertPosMemo;
	InsertPosType InsertPosDB;
	UInt32        TodaySetSeconds;
	WeekType      Today;
	WeekType      TodayDate;
	MemHandle     ConfigHandle;
	UInt16        TimeTableCategory;
	MemHandle     TimeTableAppInfoH;
	Int16 ContFileNo;
	Int16 NContFiles;
	Int32 ContFileRecNo;
	MemHandle ContFileHandle;
	Char *ContFileLastLine;
	Char ContFileLastLineBuf[STRLINEMAX];
	Char *ContFileNextLine;
	CommentMarkType CommentMark;
	UInt16        DotPattern[0x1F+1];
	Int8 NarrowList[NComments+1];
	Char ContFileName[STRMAX];
	Char Title[STRMAX];

	//>>Dialog.c
	UInt8  SeparatorMap[SeparatorMapLen];
	UInt16 MidiIndex;
	Int16  MinBefore;
	UInt32 PrevTime;

} TimeTableGlobals_t;

//========== Main.c ==============================================================================================
/*static*/ void digit2str(UInt8 x, char *p, Boolean zero) ;//MAIN_SECTION;
#ifdef HwvTimeTable_Main
static Err TimeTableAppInfoInit(DmOpenRef db) ;//MAIN_SECTION;
static void initTTVDB(void) ;//MAIN_SECTION;
#endif
/*static*/ MemHandle getAppInfo(DmOpenRef dbP) ;//MAIN_SECTION;
/*static*/ void setToday(Boolean manual) ;//MAIN_SECTION;
#ifdef HwvTimeTable_Main
static void loadDefault(void) ;//MAIN_SECTION;
static void loadPrefs(void) ;//MAIN_SECTION;
#endif
//void init_TimeTable_Params(void) ;//MAIN_SECTION;
//void draw_TimeTable(void) ;//MAIN_SECTION;
void close_TimeTable_Params(void) ;//MAIN_SECTION;
TimeTableGlobals_t* getPtrTimeTableGlobals(void) ;//MAIN_SECTION;
void freePtrTimeTableGlobals(TimeTableGlobals_t* gTTP) ;//MAIN_SECTION;
//void DEBUG_LINE(Int16 num) ;//MAIN_SECTION;
#ifdef HwvTimeTable_Main
//void drawFace(HalWatchGlobals_t* gHWP);
//void drawFace(void);
UInt32 myMain(UInt16 cmd, HalWatchGlobals_t *gP);
//void waitAppClose(void);
//UInt32 PilotMain(UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags) ;//MAIN_SECTION;
#endif



#endif //#ifndef __HwvTimeTable_H__
