// hwvTimeTable_Table.cpp Time-stamp: <2006/03/24 21:43 haru@XP4PDA05C>
// (C) 2005-2006 HAL <http://hal9.blog3.fc2.com> HAL.Kinosita@gmail.com

/*
 * TimeTable Viewer
 * Copyright(c)1999 by Hiroaki Sengoku <sengoku@gcd.org>
 * Version 0.1	Jun 19, 1999
 * Version 0.2	Jun 20, 1999
 * Version 0.3	Jun 20, 1999
 * Version 0.4	Jun 21, 1999
 * Version 0.5	Jun 22, 1999	AboutDialog
 * Version 0.6	Jun 25, 1999	SelectTrain, HardButton, PrefsDialog
 * Version 0.7	Jun 26, 1999	scroll bug fix
 * Version 0.8	Jul  3, 1999	Arrive, ShareReg, History, Transfer, StopClock
 * Version 0.9	Jul  8,	1999	multi '>', ContFile, CommentMark, scramble
 * Version 1.0	Jul 31, 1999	split bar, DB, ;;CANCEL, '\' esc, HeadType, LRU
 * Version 1.1	Aug 26, 1999	checkTimeOut
 * Version 1.2	Aug 27, 2000	Alarm, InstalledSec, LastUsedSec
 * Version 1.3  Aug  1, 2001	GPL version
 */

#include <PalmOS.h>
#include <StdIOPalm.h>
#include <WristPDA.h>
#define HwvTimeTable_Table 1
#include "hwvTimeTable.h"
#undef HwvTimeTable_Table
#include "hwvTimeTable_rsc.h"

//========== Table.c =============================================================================================
void initializeTable(void){
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	int itr;
	//DEBUG_LINE(2);
	gTTP->CurrentTable     = NULL;
	gTTP->ArriveTime       = NULL;
	gTTP->NextTrain        = 0   ;
	gTTP->TicksPerSeconds  = SysTicksPerSecond();
	for(itr=0; itr < NNumBitmaps; itr++)
		gTTP->NumBitmap[itr]   = NULL;
	gTTP->AlarmBitmap        = NULL;
	gTTP->StartupFlag        = true;
	//gTTP->MainFormPtr        = NULL;
	gTTP->AlarmDialogFlag    = false;
	//DEBUG_LINE(-1);
	gTTP->AlarmMinute        = getAlarm();
	//DEBUG_LINE(-1);
	gTTP->AlarmMinuteSave    = gTTP->AlarmMinute;
	//gTTP->NarrowOrgItemsText = NULL;
}

static void initLRU(void){
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	int itr;
	for(itr=0; itr < LRU_MAX; itr++) {
		gTTP->LRU[itr].next = itr+1;
		gTTP->LRU[itr].recordNum = -1;
	}
	gTTP->LRU[LRU_MAX-1].next = -1;
	gTTP->LRU_Top = 0;
}

void initializeTableDefault(void) {
	initLRU();
}

void initializeTableAfterPrefs(void) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	//gTTP->MainMenuBar = MenuInit(MainMenu);
	//modFileMenuItem(TimGetSeconds(),true);
	//CurrentMenuBar = NULL;
	gTTP->OffScreen = NULL;
	//MoveMenuItemStrH = NULL;
	gTTP->NarrowMode = gTTP->NarrowModeDefault;
	//BGN:byHAL
	gTTP->NarrowModeORG = gTTP->NarrowMode;
	if(gTTP->isNarrowModeInvert){
		//if(gTTP->NarrowMode >= 0) gTTP->NarrowMode = -1;
		//else                      gTTP->NarrowMode =  0; 
		gTTP->NarrowMode *= -1; gTTP->NarrowMode--;
		if (gTTP->NarrowMode >= gTTP->CurrentTable->NarrowsLen) gTTP->NarrowMode = 0;
	}
	//END:byHAL
}

static void openTable(void) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	int itr;
	//byHAL//RectangleType rct;
	//byHAL//FrmGetObjectBounds(gTTP->MainFormPtr, FrmGetObjectIndex(gTTP->MainFormPtr,MainTimeTable),&rct);

	//byHAL//RectangleType rct = { {0, 15}, {160, 145} };
	RectangleType rct = { {TimeTablePos_X0, TimeTablePos_Y0}, {TimeTablePos_Wid, TimeTablePos_Hgt} };

	//byHAL//FntSetFont(stdFont);
	FntSetFont(gTTP->font4table); //byHAL
	gTTP->ItemWidth  = FntCharsWidth("00",2) + SpaceWidth;
	gTTP->ItemHeight = FntCharHeight() + 1;
	gTTP->TableX = rct.topLeft.x;
	gTTP->TopY   = rct.topLeft.y;
	if(gTTP->NarrowMode >= 0) {
		//byHAL//gTTP->TableY = gTTP->TopY + gTTP->ItemHeight;
		//byHAL//rct.extent.y -= gTTP->ItemHeight;
		//BGN:byHAL
		FontID orgFontID = FntSetFont(gTTP->font4Note);
		gTTP->TableY = gTTP->TopY + FntCharHeight() + 1;
		rct.extent.y -= FntCharHeight() + 1;
		FntSetFont(orgFontID);
		//END:byHAL
	} else {
		gTTP->TableY = gTTP->TopY;
	}
	gTTP->NItems = rct.extent.x / gTTP->ItemWidth;
	if(gTTP->NLines < 0 || LargeClockY <= gTTP->TableY + gTTP->ItemHeight * gTTP->NLines)
		//byHAL//gTTP->NLines = rct.extent.y / gTTP->ItemHeight;
		//BGN:byHAL
		gTTP->NLinesORG = rct.extent.y / gTTP->ItemHeight;
		gTTP->NLines = (gTTP->halLayoutID == LO_TableShrink) ? NShrnkdLn : 
		               (gTTP->halLayoutID == LO_TrainTime  ) ? NTrnTimLn : gTTP->NLinesORG;
		//END:byHAL
	gTTP->TimeWidth  = FntCharsWidth("00:00:00",8);
	gTTP->TimeHeight = FntCharHeight();
	gTTP->TimeX = ScreenX - 3 - gTTP->TimeWidth;
	gTTP->TimeY = 1;
	gTTP->TimeLeftX = 82;

	//byHAL//FntSetFont(boldFont);
	FntSetFont(gTTP->fontB4Note); //byHAL
	gTTP->TimeLeftColonX = gTTP->TimeLeftX + FntCharsWidth("00",2);
	gTTP->BoldColonWidth = FntCharsWidth(":",1);
	gTTP->NormalClockRect.topLeft.x = gTTP->TimeLeftX;
	gTTP->NormalClockRect.topLeft.y = gTTP->TimeY;
	gTTP->NormalClockRect.extent.x  = FntCharsWidth("00:00",5);
	gTTP->NormalClockRect.extent.y  = FntLineHeight();

	//byHAL//FntSetFont(stdFont);
	FntSetFont(gTTP->font4Note); //byHAL
	gTTP->AlarmRect.topLeft.x = gTTP->TimeX - AlarmSize;
	gTTP->AlarmRect.topLeft.y = 0;
	gTTP->AlarmRect.extent.x = AlarmSize;
	gTTP->AlarmRect.extent.y = AlarmSize;
	gTTP->StnX = 0;
	gTTP->StnXLower = 0;
	gTTP->StnExtent = 0;

	//for(itr=0; itr < NNumBitmaps; itr++){
	//	if(NumBitmap[itr]) DmReleaseResource(NumBitmap[itr]);
	//	NumBitmap[itr] = DmGetResource('Tbmp',BitmapZero+itr);
	//}
	//gTTP->OrgAppDbRef = DmOpenDatabaseByTypeCreator('appl',	APPID, dmModeReadOnly);
	for(itr=0; itr < NNumBitmaps; itr++){
		if(gTTP->NumBitmap[itr]) DmReleaseResource(gTTP->NumBitmap[itr]);
		gTTP->NumBitmap[itr] = DmGetResource('Tbmp', BitmapZero+itr);
	}
	gTTP->AlarmBitmap = DmGetResource('Tbmp', BitmapAlarm);
	//gTTP->CurrentMenuBar = MainMenuBar;
	gTTP->ClockInvertedFlag = false;
	gTTP->StopClock = 0;
	if(gTTP->OffScreen) WinDeleteWindow(gTTP->OffScreen,false);
	//byHAL//gTTP->OffScreen = WinCreateOffscreenWindow(ScreenX,gTTP->ItemHeight,screenFormat,&(gTTP->OffScreenErr));
	//BGN:byHAL
	{
		FontID orgFont = FntSetFont(FossilLedFont); //Ƃ肠ԑ傫ȃtHg̍Ŋm
		gTTP->OffScreen = WinCreateOffscreenWindow(ScreenX,FntCharHeight(),screenFormat,&(gTTP->OffScreenErr));
		FntSetFont(orgFont);
	}
	//END:byHAL
	//DmCloseDatabase(gTTP->OrgAppDbRef);
}

//void closeTable(void) { // gTTP |C^̊Jɓ̏
//	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
//	Int16 i;
//	//unselectItem();
//	//if (gTTP->NarrowOrgItemsText && gTTP->MainFormPtr) {
//	//	ListPtr list;
//	//	UInt16 lindex;
//	//	lindex = FrmGetObjectIndex(gTTP->MainFormPtr,MainPopupListNarrow);
//	//	list = FrmGetObjectPtr(gTTP->MainFormPtr,lindex);
//	//	list->itemsText = gTTP->NarrowOrgItemsText;
//	//	list->numItems = gTTP->NarrowOrgNumItems;
//	//	list->bounds.extent.x = gTTP->NarrowOrgItemWidth;
//	//	gTTP->NarrowOrgItemsText = NULL;
//	//}
//	if (gTTP->CurrentTable) {
//		disposeTimeTable(gTTP->CurrentTable);
//		gTTP->CurrentTable = NULL;
//	}
//	if (gTTP->ArriveTime) {
//		MemPtrFree(gTTP->ArriveTime);
//		gTTP->ArriveTime = NULL;
//	}
//	for (i=0; i < NNumBitmaps; i++) {
//		if (gTTP->NumBitmap[i]) {
//	    DmReleaseResource(gTTP->NumBitmap[i]);
//	    gTTP->NumBitmap[i] = NULL;
//		}
//	}
//	if (gTTP->AlarmBitmap) DmReleaseResource(gTTP->AlarmBitmap);
//	if (gTTP->OffScreen) {
//		WinDeleteWindow(gTTP->OffScreen,false);
//		gTTP->OffScreen = NULL;
//	}
//}

static Boolean getLRU(Int32 record) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	int itr1, itr2=0, itr3=-1, itr4=-1;
	for(itr1=gTTP->LRU_Top; itr1 >= 0; itr1=gTTP->LRU[itr1].next){
		if(gTTP->LRU[itr1].recordNum == record){
	    if(itr3 >= 0){
				gTTP->LRU[itr3].next = gTTP->LRU[itr1].next;
				gTTP->LRU[itr1].next = gTTP->LRU_Top;
				gTTP->LRU_Top = itr1;
	    }
	    return true;
		}
		itr4 = itr3;
		itr3 = itr1;
		itr2++;
	}
	if(itr4 >= 0 && itr3 >= 0 && itr2 == LRU_MAX){
		gTTP->LRU[itr4].next = gTTP->LRU[itr3].next;	/* not found */
		gTTP->LRU[itr3].next = gTTP->LRU_Top;
		gTTP->LRU_Top = itr3;
	}else{
		//PrivErrDisplay("Can't happen: LRU shorten",false);
		initLRU();
	}
	gTTP->LRU[gTTP->LRU_Top].recordNum       = record;
	gTTP->LRU[gTTP->LRU_Top].OfsArrive       = 0;
	gTTP->LRU[gTTP->LRU_Top].ShowArrivesFlag = gTTP->ShowArrivesFlag;
	gTTP->LRU[gTTP->LRU_Top].NarrowMode      = gTTP->NarrowModeDefault;
	//byHAL//gTTP->LRU[gTTP->LRU_Top].NLines          = gTTP->NLines;
	gTTP->LRU[gTTP->LRU_Top].NLines          = gTTP->NLinesORG; //byHAL
	return false;
}

static void putLRU(void) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	if (gTTP->LRU_Top < 0) {
		//PrivErrDisplay("Can't happen: LRU_Top < 0",false);
		initLRU();
		gTTP->LRU[gTTP->LRU_Top].recordNum = gTTP->TrainTimeRecordNum;
	}
	if (gTTP->LRU[gTTP->LRU_Top].recordNum != gTTP->TrainTimeRecordNum) {
		//PrivErrDisplay("Can't happen: "
		//							 "LRU[LRU_Top].recordNum != TrainTimeRecordNum",false);
		getLRU(gTTP->TrainTimeRecordNum);
	}
	gTTP->LRU[gTTP->LRU_Top].OfsArrive = gTTP->OfsArrive;
	gTTP->LRU[gTTP->LRU_Top].ShowArrivesFlag = gTTP->ShowArrivesFlag;
	//byHAL//gTTP->LRU[gTTP->LRU_Top].NarrowMode = gTTP->NarrowMode;
	gTTP->LRU[gTTP->LRU_Top].NarrowMode = gTTP->NarrowModeORG; //byHAL
	//byHAL//gTTP->LRU[gTTP->LRU_Top].NLines = gTTP->NLines;
	gTTP->LRU[gTTP->LRU_Top].NLines = gTTP->NLinesORG; //byHAL
}

static void setFirstLastTrain(void){
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	LineType **Lines    = gTTP->CurrentTable->Lines;
	Int16      LinesLen = gTTP->CurrentTable->LinesLen;
	Int16 i, j;
	gTTP->FirstTrain = gTTP->LastTrain = -1;
	for(i=0; i < LinesLen; i++) {
		for(j=0; j < Lines[i]->length; j++) {
	    if(gTTP->FirstTrain < 0)
				gTTP->FirstTrain = Lines[i]->hour * 60 + Lines[i]->items[j].minute;
	    gTTP->LastTrain = Lines[i]->hour * 60 + Lines[i]->items[j].minute;
		}
	}
	if (gTTP->LastTrain < gTTP->FirstTrain) gTTP->LastTrain += 24 * 60;
}

/*static*/ Boolean loadTrainTimeDB(Int32 recordNum){
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	Int16 prev = gTTP->NarrowMode;
	if(getLRU(recordNum)){
		gTTP->OfsArrive       = gTTP->LRU[gTTP->LRU_Top].OfsArrive;
		gTTP->ShowArrivesFlag = gTTP->LRU[gTTP->LRU_Top].ShowArrivesFlag;
		gTTP->NarrowMode      = gTTP->LRU[gTTP->LRU_Top].NarrowMode;
		//BGN:byHAL
		gTTP->NarrowModeORG = gTTP->NarrowMode;
		if(gTTP->isNarrowModeInvert){
			//if(gTTP->NarrowMode >= 0) gTTP->NarrowMode = -1;
			//else                      gTTP->NarrowMode =  0; 
			gTTP->NarrowMode *= -1; gTTP->NarrowMode--;
			if (gTTP->NarrowMode >= gTTP->CurrentTable->NarrowsLen) gTTP->NarrowMode = 0;
		}
		//END:byHAL*/
		prev = gTTP->NarrowMode;
		//byHAL//gTTP->NLines          = gTTP->LRU[gTTP->LRU_Top].NLines;
		//BGN:byHAL
		gTTP->NLinesORG       = gTTP->LRU[gTTP->LRU_Top].NLines;
		gTTP->NLines          = (gTTP->halLayoutID == LO_TableShrink) ? NShrnkdLn : 
			                      (gTTP->halLayoutID == LO_TrainTime  ) ? NTrnTimLn : gTTP->NLinesORG; //byHAL
		//END:byHAL
	}else{
		gTTP->NarrowMode      = gTTP->NarrowModeDefault;
		//BGN:byHAL
		gTTP->NarrowModeORG = gTTP->NarrowMode;
		if(gTTP->isNarrowModeInvert){
			//if(gTTP->NarrowMode >= 0) gTTP->NarrowMode = -1;
			//else                      gTTP->NarrowMode =  0; 
			gTTP->NarrowMode *= -1; gTTP->NarrowMode--;
			if (gTTP->NarrowMode >= gTTP->CurrentTable->NarrowsLen) gTTP->NarrowMode = 0;
		}
		//END:byHAL*/
	}
	//byHAL//if(     prev >= 0 && gTTP->NarrowMode <  0) gTTP->NLines++;
	//byHAL//else if(prev <  0 && gTTP->NarrowMode >= 0) gTTP->NLines--;
	//BGN:byHAL
	if(     prev >= 0 && gTTP->NarrowMode <  0){ gTTP->NLinesORG++; if(gTTP->halLayoutID == LO_Org) gTTP->NLines++; }
	else if(prev <  0 && gTTP->NarrowMode >= 0){ gTTP->NLinesORG--; if(gTTP->halLayoutID == LO_Org) gTTP->NLines--; }
	//END:byHAL
	if(loadDB(recordNum)) {
		//DEBUG_LINE(-1);
		gTTP->TrainTimeRecordNum = recordNum;
		if(gTTP->OfsArrive >= gTTP->CurrentTable->ArrivesLen) gTTP->OfsArrive = 0;
		//updateOptionMenuItem();
		setFirstLastTrain();
		//DEBUG_LINE(-1);
		return true;
	}
	//DEBUG_LINE(-1);
	return false;
}

static UInt16 getUInt16(UInt8 *p) {	/* return *p */
	UInt16 ret;
	ret = *p++ << 8;	/* MSB Big endian */
	ret |= *p++;	/* LSB */
	return ret;
}

static Boolean getComments(TimeTableType *table, Int16 item, Int16 line, Int8 *comments) {
	//TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	/* never use CommentsTmp[] */
	LineType **Lines = table->Lines;
	Int16 LinesLen = table->LinesLen;
	Int16 ncom = 0;
	Int8 *excom;
	Int16 j, k, exlen;
	if (line < 0 || LinesLen <= line
			|| item < 0 || Lines[line]->length <= item
			|| Lines[line]->items[item].comment < 0) {	/* no comments */
		*comments = -1;
		return false;
	}
	comments[ncom++] = Lines[line]->items[item].comment;
	exlen = (Int16)getUInt16(&Lines[line]->excom_msb);
	if (exlen) {
		excom = (Int8*)&Lines[line]->items[(Int16)Lines[line]->length];
		for (j=0, k=0; j < exlen; j++) {
	    if (k >= item) {
				for (; j < exlen; j++) {
					if (excom[j] < 0 || ncom >= ExCommentsMax - 1) break;
					comments[ncom++] = excom[j];
				}
				break;
	    }
	    if (excom[j] == -1) k++;
		}
	}
	comments[ncom] = -1;
	return true;
}

static void drawComment(Int8 *coms, Int16 width, Int16 x, Int16 y) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	/* never use CommentsTmp[] */
	Int16 endX = x + width;
	Int16 len;
	Boolean ok;
	Int16 com;
	Char *str;
	RectangleType r;
	if (*coms < 0) {
		com = NoComment;	/* without comments */
		if (gTTP->CurrentTable->Comments) goto draw;
		else goto erase;
	}
	while ((com=*coms++) >= 0) {
	draw:
		str = gTTP->CurrentTable->Comments[com];
		len = StrLen(str);
		width = endX - x;
		ok = true;
		FntCharsInWidth(str,&width,&len,&ok);
		if (*str && len <= 0) break;
		//byHAL//WinDrawChars(str,len,x,y);
		/*xqx*/ WinDrawChars(str,len,x,y);//,y-1); //byHAL
		width = FntCharsWidth(str,len);
		x += width;
	}
 erase:
	r.topLeft.x = x;
	r.topLeft.y = y;
	r.extent.x = endX - x;
	r.extent.y = FntCharHeight();
	/*xqx*/ WinEraseRectangle(&r,0);
}

static Boolean commentMatch(Int8 **pp, Int8 *coms) {
	Int8 *p, *q;
	Boolean ret = false;
	p = *pp;
	if (*p == -1) {
		ret = true;
		p++;
	} else if (coms) {
		while (*p >= 0) {
	    for (q=coms; *q >= 0; q++)
				if (*p == *q) ret = true;
	    p++;
		}
		if (*p == -1) p++;
	}
	*pp = p;
	return ret;
}

static Int16 timeRequired(TimeTableType *table, Int16 stn, Int8 *coms) {
	Int8 *p;
	Int16 min = -1;
	Int16 i;
	Boolean nocom;
	p = (Int8*)table->Arrives[stn];
	while (*p) p++;
	p++;
	p += 2;	/* trpos */
	while (*p >= -1) {	/* -1: end of comments, -2: end of line */
		nocom = (*p == -1);
		if (commentMatch(&p,coms)) {
	    i = (Int16)getUInt16((UInt8*)p);
	    if (nocom && i == -2	/* '=' only */
					&& *coms >= 0) {	/* train w/ notes */
				;	/* '=' match to the train w/o notes */
	    } else {
				min = i;
	    }
		}
		p += sizeof(UInt16);
	}
	return min;
}

static void loadArrives(TimeTableType *table,	Int16 column, Int16 minute, Int8 *coms) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	/* never use CommentsTmp[] */
	Int16 ArrivesLen = table->ArrivesLen;
	Int16 min, i;
	for (i=0; i < ArrivesLen; i++) {
		if (minute < 0) gTTP->ArriveTime[ArrivesLen*column+i] = -2;	/* no train */
		else {
	    min = timeRequired(table,i,coms);
	    if (min > 60) {	/* long trip */
				gTTP->ArriveTime[ArrivesLen*column+i] = (minute + min) % (60*24);
	    } else if (min >= 0) {
				gTTP->ArriveTime[ArrivesLen*column+i] = minute + min;
	    } else {
				gTTP->ArriveTime[ArrivesLen*column+i] = -1;	/* pass */
	    }
		}
	}
}

static Boolean nextTrain(Int16 *itemP, Int16 *lineP) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	LineType **Lines = gTTP->CurrentTable->Lines;
	Int16 LinesLen = gTTP->CurrentTable->LinesLen;
	Int16 item, line;
	Int16 i = 1;
	if (*itemP < 0 || *lineP < 0) return false;
	item = *itemP;
	item++;
	for (line=*lineP; line < LinesLen; line++) {
		while (item < Lines[line]->length) {
	    if (Lines[line]->items[item].mark != CancelMark && --i <= 0) {
				*itemP = item;
				*lineP = line;
				return true;
	    } else {
				item++;
	    }
		}
		item = 0;
	}
	return false;
}

static Boolean isLargeClockShown() {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	return gTTP->LargeClockFlag && !gTTP->StopClock && gTTP->TransNLines <= 0;
}

static Char *transFile(Int16 n) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	Int16 len = StrLen(gTTP->CurrentTable->Arrives[n]);
	UInt8 *p;
	Int16 trpos;
	p = (UInt8*)(gTTP->CurrentTable->Arrives[n] + len + 1);
	trpos = (Int16)getUInt16(p);
	if (trpos) {
		return (Char *)(p + trpos);
	} else {
		return NULL;
	}
}

static Boolean isTransfer(Int16 n) {
	Char *p = transFile(n);
	return p != NULL;
}



/*
inline Int16    HourWidth(TimeTableGlobals_t* gTTP){ return gTTP->ItemWidth +2; }
//inline Int16  TableRightX(TimeTableGlobals_t* gTTP){ return gTTP->TableX + HourWidth(gTTP) + gTTP->ItemWidth * gTTP->NItems; }
inline Int16  TableRightX(TimeTableGlobals_t* gTTP){ return gTTP->TableX + gTTP->ItemWidth +2 + gTTP->ItemWidth * gTTP->NItems; }
inline Int16 TableBottomY(TimeTableGlobals_t* gTTP){ return gTTP->TableY + gTTP->ItemHeight * gTTP->NLines; }
inline Int16 CommentsHeight(TimeTableGlobals_t* gTTP){ return gTTP->ItemHeight-1; }
Int16 commentY(Int16 line, TimeTableGlobals_t* gTTP) {
	Int16 tCommentsHeight = (gTTP->ItemHeight-1);
	Int16 tCommBottomY = gTTP->TransNLines ? (ScreenY - tCommentsHeight * gTTP->TransNLines - 1) : ScreenY;
	return tCommBottomY - tCommentsHeight * (((tCommBottomY - TableBottomY(gTTP))/ tCommentsHeight) - line);
}
Int16 NShowComments(TimeTableGlobals_t* gTTP){
	Int16 tCommentsHeight = (gTTP->ItemHeight-1);
	Int16 tCommBottomY = gTTP->TransNLines ? (ScreenY - tCommentsHeight * gTTP->TransNLines - 1) : ScreenY;
	return (tCommBottomY-TableBottomY(gTTP))/tCommentsHeight;
}
#define LargeClockX	(ScreenX-NumBitmapX*4-ColonBitmapX)
#define LargeClockY	(ScreenY-NumBitmapY)
//#define LargeClockLines	(NumBitmapY/CommentsHeight+1)
Int16 LargeClockLines(TimeTableGlobals_t* gTTP){ return NumBitmapY/CommentsHeight(gTTP)+1; }
*/
/**/
static Int16       HourWidth(TimeTableGlobals_t* gTTP) TABLE_SECTION;
static Int16     TableRightX(TimeTableGlobals_t* gTTP) TABLE_SECTION;
static Int16    TableBottomY(TimeTableGlobals_t* gTTP) TABLE_SECTION;
static Int16  CommentsHeight(TimeTableGlobals_t* gTTP) TABLE_SECTION;
static Int16 commentY(Int16 line, TimeTableGlobals_t* gTTP, Boolean isArriveMode) TABLE_SECTION;
static Int16   NShowComments(TimeTableGlobals_t* gTTP) TABLE_SECTION;
static Int16 LargeClockLines(TimeTableGlobals_t* gTTP) TABLE_SECTION;

static Int16    HourWidth(TimeTableGlobals_t* gTTP){ return gTTP->ItemWidth +2; }
//static Int16  TableRightX(TimeTableGlobals_t* gTTP){ return gTTP->TableX + HourWidth(gTTP) + gTTP->ItemWidth * gTTP->NItems; }
static Int16  TableRightX(TimeTableGlobals_t* gTTP){ return gTTP->TableX + gTTP->ItemWidth +2 + gTTP->ItemWidth * gTTP->NItems; }
static Int16 TableBottomY(TimeTableGlobals_t* gTTP){ return gTTP->TableY + gTTP->ItemHeight * gTTP->NLines; }
static Int16 CommentsHeight(TimeTableGlobals_t* gTTP){ return gTTP->ItemHeight-1; }
#if 0 //byHAL
static Int16 commentY(Int16 line, TimeTableGlobals_t* gTTP) {
	Int16 tCommentsHeight = (gTTP->ItemHeight-1);
	Int16 tCommBottomY = gTTP->TransNLines ? (ScreenY - tCommentsHeight * gTTP->TransNLines - 1) : ScreenY;
	return tCommBottomY - tCommentsHeight * (((tCommBottomY - TableBottomY(gTTP))/ tCommentsHeight) - line);
}
#else //BGN:byHAL
static Int16 commentY(Int16 line, TimeTableGlobals_t* gTTP, Boolean isArriveMode) {
	FontID orgFont;
	Int16 itr = 0, posY = TableBottomY(gTTP)+3;
	if(line == 0) return posY; 
	orgFont = FntSetFont(gTTP->font4Note);
	if(!isArriveMode){
		FntSetFont(gTTP->font4NoteTop); itr = 1;              posY += FntCharHeight() + 2;
	}
	FntSetFont(gTTP->font4Note   ); for( ; itr<line; itr++) posY += FntCharHeight() + 2;
	FntSetFont(orgFont);
	return posY;
}
#endif //END:byHAL
static Int16 NShowComments(TimeTableGlobals_t* gTTP){
	Int16 tCommentsHeight = (gTTP->ItemHeight-1);
	Int16 tCommBottomY = gTTP->TransNLines ? (ScreenY - tCommentsHeight * gTTP->TransNLines - 1) : ScreenY;
	return (tCommBottomY-TableBottomY(gTTP))/tCommentsHeight;
}
#define LargeClockX	(ScreenX-NumBitmapX*4-ColonBitmapX)
#define LargeClockY	(ScreenY-NumBitmapY)
//#define LargeClockLines	(NumBitmapY/CommentsHeight+1)
static Int16 LargeClockLines(TimeTableGlobals_t* gTTP){ return NumBitmapY/CommentsHeight(gTTP)+1; }
/**/



static void drawArrive(Int16 n) {	/* n = -1: header */
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	Int16 ArrivesLen = gTTP->CurrentTable->ArrivesLen;
	Char **Arrives = gTTP->CurrentTable->Arrives;
	RectangleType r;
	Int16 endX, x, y, hwidth, bwidth, width, len;
	Boolean lowerPart;
	Boolean ok;
	Int16 ohour, tim, otim, hour, min, col;
	Char str[10];
	Int16 nlines = NShowComments(gTTP);
	WinHandle win = WinGetDrawWindow();	/* save current */
	if (gTTP->ArriveTimeHeadType > HeadNone) nlines--;
	//byHAL//if (!gTTP->ArriveBarFlag) endX = ScreenX;	/* no scroll bar */
	//byHAL//else endX = gTTP->ArriveRightX;
	endX = ScreenX; //byHAL
	if (nlines - LargeClockLines(gTTP) <= n) {
		lowerPart = true;
		//byHAL//if (isLargeClockShown()) endX = LargeClockX;
	} else {
		lowerPart = false;
	}
	r.topLeft.x = gTTP->TableX;
	r.topLeft.y = 0;
	r.extent.x = endX - r.topLeft.x;
	//byHAL//r.extent.y = CommentsHeight(gTTP);
	r.extent.y = FntCharHeight(); //byHAL
	x = r.topLeft.x;
	y = r.topLeft.y;
	WinSetDrawWindow(gTTP->OffScreen);
	WinEraseRectangle(&r,0);
	if (gTTP->OfsArrive + n >= ArrivesLen) goto copy;
	//byHAL//FntSetFont(boldFont);
	FntSetFont(gTTP->fontB4Note); //byHAL
	hwidth = FntCharsWidth("00:",3);
	bwidth = FntCharsWidth("00",2) + SpaceWidth;
	//byHAL//FntSetFont(stdFont);
	FntSetFont(gTTP->font4Note);//byHAL
	//byHAL//width = gTTP->ItemWidth;	/* FntCharsWidth("00",2) + SpaceWidth */
	width = FntCharsWidth("00",2) + SpaceWidth;
	otim = -1;
	ohour = -1;
	for (col=0; col < gTTP->ArrivesColumn; col++) {
		if (col > 0 && hwidth+width*(col+2) > r.extent.x) break;
		if (n == -1) {
	    tim = gTTP->ArriveTimeHead[col];
	    if (tim < 0) break;
		} else {
	    if (gTTP->ArriveTime[ArrivesLen*col+gTTP->OfsArrive+n] < -1) break;
	    tim = gTTP->ArriveTime[ArrivesLen*col+gTTP->OfsArrive+n];
		}
		if (tim >= 0) {
	    hour = tim/60;
	    min = tim%60;
	    if (ohour < 0) {
				digit2str(HOUR(hour, gTTP->TwelveFlag),str,true);
				str[2] = ':';
				str[3] = '\0';
				//byHAL//FntSetFont(boldFont);
				FntSetFont(gTTP->fontB4Note);//byHAL
				WinDrawChars(str,3,x,y);
				if (gTTP->TwelveFlag && 12 <= hour && hour <= 23) {
					//byHAL//WinDrawLine(x+2,y+CommentsHeight(gTTP)-1, x+bwidth-SpaceWidth-4,y+CommentsHeight(gTTP)-1);
					WinDrawLine(x+2,y+r.extent.y-1, x+bwidth-SpaceWidth-4,y+r.extent.y-1);
				}
				//byHAL//FntSetFont(stdFont);
				FntSetFont(gTTP->font4Note);//byHAL
				ohour = hour;
	    }
	    if (col == 0) {
				digit2str(min,str,true);
				//byHAL//FntSetFont(boldFont);
				FntSetFont(gTTP->fontB4Note);//byHAL
				WinDrawChars(str,2,x+hwidth,y);
				//byHAL//FntSetFont(stdFont);
				FntSetFont(gTTP->font4Note);//byHAL
				if (n == -1 && gTTP->ArriveTimeHeadMark[col] > UnMark)
					invertXY(x+hwidth+2,y,(CommentMarkType)(gTTP->ArriveTimeHeadMark[col]));
	    } else {
				digit2str(min,str,true);
				WinDrawChars(str,2,x+hwidth+bwidth+width*(col-1),y);
				if (n == -1 && gTTP->ArriveTimeHeadMark[col] > UnMark)
					invertXY(x+hwidth+bwidth+width*(col-1),y, (CommentMarkType)(gTTP->ArriveTimeHeadMark[col]));
	    }
	    if (tim < otim && otim - tim < 20 * 60) {	/* col > 0 */
				//byHAL//WinDrawLine(x+hwidth+bwidth+width*(col-1)+2, y+CommentsHeight(gTTP)-1, 
				//byHAL//						x+hwidth+bwidth+width*(col-1)+width-SpaceWidth-3, y+CommentsHeight(gTTP)-1);
				WinDrawLine(x+hwidth+bwidth+width*(col-1)+2, y+r.extent.y-1, 
										x+hwidth+bwidth+width*(col-1)+width-SpaceWidth-3, y+r.extent.y-1);
	    }
	    otim = tim;
		} else {
	    if (col == 0) {
				WinDrawChars("--",2,x+hwidth+bwidth-width,y);
	    } else {
				WinDrawChars("--",2,x+hwidth+bwidth+width*(col-1),y);
	    }
		}
		if (n == -1 && gTTP->ArriveTimeHeadType == HeadNote) {
	    col = 1;
	    break;
		}
	}
	width = hwidth + bwidth + width * (col-1);
	x += width;
	width = r.extent.x - width;
	if (n >= 0) {
		len = StrLen(Arrives[gTTP->OfsArrive+n]);
		ok = true;
		FntCharsInWidth(Arrives[gTTP->OfsArrive+n],&width,&len,&ok);
		WinDrawChars(Arrives[gTTP->OfsArrive+n],len,x,y);
		width = FntCharsWidth(Arrives[gTTP->OfsArrive+n],len);
		if (isTransfer(gTTP->OfsArrive+n)) {	/* transfer */
	    //byHAL//WinDrawLine(x-1,y+CommentsHeight(gTTP)-1,x+width,y+CommentsHeight(gTTP)-1);
	    WinDrawLine(x-1,y+r.extent.y-1,x+width,y+r.extent.y-1);
		}
		if (width > gTTP->StnExtent) gTTP->StnExtent = width;
		if (lowerPart) gTTP->StnXLower = x;
		else gTTP->StnX = x;
	} else {
		if (gTTP->ArriveTimeHeadType >= HeadNote && gTTP->SelItem >= 0 && gTTP->SelLine >= 0) {
	    getComments(gTTP->CurrentTable,gTTP->SelItem,gTTP->SelLine,gTTP->CommentsTmp);
	    drawComment(gTTP->CommentsTmp,width,x,y);
		}
	}
 copy:
	x = gTTP->TableX;
	if (gTTP->ArriveTimeHeadType > HeadNone) y = commentY(n + 1, gTTP, true);
	else y = commentY(n, gTTP, true);
	WinCopyRectangle(gTTP->OffScreen,win,&r,x,y, winPaint);//scrCopy);
	WinSetDrawWindow(win);	/* restore */
}

static void drawArrives(void) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	Int16 nlines = NShowComments(gTTP);
	Int16 i;
	if (gTTP->ArriveTimeHeadType > HeadNone) {
		nlines--;
		drawArrive(-1);	/* draw header */
	}
	if (gTTP->CurrentTable->ArrivesLen <= 1 /* nlines */)
		gTTP->OfsArrive = 0;	/* no scroll */
	for (i=0; i < nlines; i++) {
		drawArrive(i);
	}
}

//static void drawLowerSplit(Boolean draw) {
//	/* lower split bar */
//#if 0
//	if (ScreenY <= CommBottomY) {
//		if (draw) WinDrawLine(ScreenX-7,ScreenY-1,ScreenX-1,ScreenY-1);
//		else WinEraseLine(ScreenX-7,ScreenY-1,ScreenX-1,ScreenY-1);
//	} else {
//		if (draw) WinDrawLine(TableX,CommBottomY,ScreenX-1,CommBottomY);
//		else WinEraseLine(TableX,CommBottomY,ScreenX-1,CommBottomY);
//	}
//#endif
//}

static void showComment(Int16 n, Char *time, Int8 *coms, Boolean flag) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	RectangleType r;
	Int16 x, y, endX;
	WinHandle win = WinGetDrawWindow();	/* save current */
	endX = ScreenX;
	//byHAL// Ԗ̕\Cłc莞ԕ\̕邩ۂ
	//byHAL//if (isLargeClockShown()
	//byHAL//		&& NShowComments(gTTP) - LargeClockLines(gTTP) <= n) endX = LargeClockX;
	if(n==0) FntSetFont(gTTP->font4NoteTop); //byHAL
	else     FntSetFont(gTTP->font4Note   ); //byHAL
	r.topLeft.x = gTTP->TableX;
	r.topLeft.y = 0;
	r.extent.x = endX - r.topLeft.x;
	//byHAL//r.extent.y = CommentsHeight(gTTP);
	r.extent.y = FntCharHeight(); //byHAL
	x = r.topLeft.x;
	y = r.topLeft.y;
	WinSetDrawWindow(gTTP->OffScreen);
	/*xqx*/ WinEraseRectangle(&r,0);
	if (time && gTTP->CurrentTable->Comments) {
		WinDrawChars(time,StrLen(time),x,y);
		if (flag)
	    //byHAL//WinDrawLine(x+2,y+CommentsHeight(gTTP)-1,	x+gTTP->ItemWidth-SpaceWidth-4,y+CommentsHeight(gTTP)-1);
	    WinDrawLine(x+2,y+r.extent.y-1,	x+gTTP->ItemWidth-SpaceWidth-4,y+r.extent.y-1);
		x += FntCharsWidth(time,StrLen(time));
		drawComment(coms,endX-x,x,y);
	}
	x = gTTP->TableX;
	y = commentY(n, gTTP, false);
	/*xqx*/ WinCopyRectangle(gTTP->OffScreen,win,&r,x,y,winPaint);//scrCopy);
	WinSetDrawWindow(win);	/* restore */
}

static void showCommentLine(Int16 n) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	LineType **Lines = gTTP->CurrentTable->Lines;
	Int16 LinesLen = gTTP->CurrentTable->LinesLen;
	Int16 i, hour, min;
	Int16 item, line;
	Char str[10];
	Boolean flag;
	item = gTTP->SelItem;
	line = gTTP->SelLine;
	i = 0;
	for (;;) {
		if (0 <= line && line < LinesLen) {
	    if (item >= Lines[line]->length) {
				item = 0;
				line++;
				continue;
	    }
	    if (!gTTP->ShowCommentsFlag || gTTP->UnderlineSpecialFlag
					|| Lines[line]->items[item].comment >= 0
					|| i == 0) {
				if (i >= n) {
					hour = Lines[line]->hour;
					min = Lines[line]->items[item].minute;
					getComments(gTTP->CurrentTable,item,line,gTTP->CommentsTmp);
					flag = false;
					if (gTTP->OmitHourFlag) {
						digit2str(min,str,true);
						str[2] = ' ';
						str[3] = '\0';
					} else {
						/*	StrPrintF(str,"%02d:%02d ",hour,min);	*/
						digit2str(HOUR(hour, gTTP->TwelveFlag),str,true);
						str[2] = ':';
						digit2str(min,&str[3],true);
						str[5] = ' ';
						str[6] = '\0';
						if (gTTP->TwelveFlag && 12 <= hour && hour <= 23)
							flag = true;
					}
					//if(i==0) FntSetFont(largeFont); //byHAL
					showComment(n,str,gTTP->CommentsTmp,flag);
					//FntSetFont(stdFont); //byHAL
					return;
				}
				i++;
	    }
	    item++;
		} else {
	    showComment(n,NULL,NULL,false);
	    return;
		}
	}
}

static void showComments(void) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	Int16 i;
	Int16 nlines = NShowComments(gTTP);
	for (i=0; i < nlines; i++) showCommentLine(i);
}

static void selectItem(Int16 item, Int16 line, Boolean draw) {	/* [cell] */
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	Int16 i;
	Boolean drawBar = false;
	if (item >= 0 && line >= 0) {
		invertItem(gTTP->SelItem,gTTP->SelLine,InvertMark,false);
		invertItem(item,line,InvertMark,false);
		gTTP->SelItem = item;
		gTTP->SelLine = line;
	} else {
		item = gTTP->SelItem;
		line = gTTP->SelLine;
		drawBar = true;
	}
	gTTP->StnExtent = 0;
	if (draw) {
		if (gTTP->NarrowMode >= 0) {
	    Int16 nc = -1, j;
	    getComments(gTTP->CurrentTable,item,line,gTTP->CommentsTmp);
	    if (gTTP->NarrowList[0] >= 0 && gTTP->NarrowList[1] == -1) {
				nc = gTTP->NarrowList[0];
				for (i=0, j=0; gTTP->CommentsTmp[i] >= 0; i++) {	/* remove nc */
					if (nc == gTTP->CommentsTmp[i]) continue;
					gTTP->CommentsTmp[j] = gTTP->CommentsTmp[i];
					j++;
				}
				gTTP->CommentsTmp[j] = -1;
	    }
	    //byHAL//drawComment(gTTP->CommentsTmp, ScreenX - gTTP->NarrowEndX, gTTP->NarrowEndX, gTTP->TopY);//gʁh
			//BGN:byHAL//l胂[hŎ\̏ɕ\gsFʁh́gsFh
			{
				FontID orgFontID = FntSetFont(gTTP->font4Note);
				Int16 nNarrowStrLen = 0;
				gTTP->NarrowEndX = gTTP->TableX;
				if(nc != -1 && gTTP->NarrowMode > 1){
					nNarrowStrLen = StrLen(gTTP->CurrentTable->Narrows[gTTP->NarrowMode]);
					if(nNarrowStrLen > 0){
						WinDrawChars(gTTP->CurrentTable->Narrows[gTTP->NarrowMode], nNarrowStrLen, gTTP->NarrowEndX, gTTP->TopY); 
						gTTP->NarrowEndX += FntCharsWidth(gTTP->CurrentTable->Narrows[gTTP->NarrowMode], nNarrowStrLen);
					}
				}
				else if(gTTP->NarrowMode == 0 || gTTP->NarrowMode == 1){
					MemHandle mhStr = DmGet1Resource('tSTR', SrID_NarrowMode0 + gTTP->NarrowMode);
					if(mhStr != NULL){
						Char *pStr = (Char*)MemHandleLock(mhStr);
						if(pStr != NULL){
							nNarrowStrLen = StrLen(pStr);
							if(nNarrowStrLen > 0){
								WinDrawChars(pStr, nNarrowStrLen, gTTP->NarrowEndX, gTTP->TopY); 
								gTTP->NarrowEndX += FntCharsWidth(pStr, nNarrowStrLen);
							}
						}
						MemHandleUnlock(mhStr);
					}
					DmReleaseResource(mhStr);
				}
				WinDrawChars(" : ", 3, gTTP->NarrowEndX, gTTP->TopY); 
				gTTP->NarrowEndX += FntCharsWidth(" : ", 3);
				drawComment(gTTP->CommentsTmp, ScreenX - gTTP->NarrowEndX, gTTP->NarrowEndX, gTTP->TopY);//gʁh
				FntSetFont(orgFontID);
			}
			//END:byHAL
		}
		if (gTTP->ShowArrivesFlag && gTTP->CurrentTable->ArrivesLen > 0) {
	    LineType **Lines = gTTP->CurrentTable->Lines;
	    for (i=0; i < gTTP->ArrivesColumn; i++) {
				if (item < 0 || line < 0) { /* no train */
					gTTP->ArriveTimeHead[i] = -1;
					gTTP->ArriveTimeHeadMark[i] = UnMark;
					loadArrives(gTTP->CurrentTable,i,-1,NULL);
				} else {
					gTTP->ArriveTimeHead[i] = xy2train(item,line,true);
					gTTP->ArriveTimeHeadMark[i] = Lines[line]->items[item].mark;
					getComments(gTTP->CurrentTable,item,line,gTTP->CommentsTmp);
					loadArrives(gTTP->CurrentTable,i,gTTP->ArriveTimeHead[i],gTTP->CommentsTmp);
				}
				if (item < 0 || line < 0 || !nextTrain(&item,&line)) {
					item = line = -1;
				}
	    }
	    //updateArriveBar(draw && drawBar);
	    drawArrives();
	    //drawLowerSplit(true);
		} else {
	    showComments();
		}
	}
	gTTP->SelectTrain = xy2train(gTTP->SelItem,gTTP->SelLine,true);
	if (gTTP->SelectTrain < gTTP->FirstTrain) gTTP->SelectTrain += 24 * 60;
}

static void unselectItem(void) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	gTTP->SelItem = gTTP->SelLine = -1;
	gTTP->SelectTrain = -1;
	gTTP->SelectCurrentFlag = false;
	gTTP->ManualSelectFlag = false;	/* automatically unselected */
}

/*static*/ void restoreHisAttr(Int16 pos) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	gTTP->StopClock        = gTTP->HisAttr[pos].StopClock;
	gTTP->ManualSelectFlag = gTTP->HisAttr[pos].ManualSelectFlag;
	if(gTTP->ManualSelectFlag) {
		gTTP->SelItem = gTTP->HisAttr[pos].SelItem;
		gTTP->SelLine = gTTP->HisAttr[pos].SelLine;
	} else {
		unselectItem();
	}
}

static Int32 backHistory(void) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	UInt32 time;
	Int16 cur;
	cur = gTTP->HistoryCur - 1;
	if (cur < 0) cur += HISTORYMAX;
	//byHAL//if (cur == gTTP->HistoryBot) return -1;
	if(cur == gTTP->HistoryBot) cur = gTTP->HistoryTop; //byHAL
	//byHAL//time = TimGetSeconds();
	time = TimDateTimeToSeconds(&(gTTP->gHWP->cDateTime)); //byHAL
	restoreHisAttr(cur);
	if (gTTP->StopClock <= time) gTTP->StopClock = 0;
	return gTTP->History[gTTP->HistoryCur=cur];
}

static Int32 forwardHistory(void) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	UInt32 time;
	//byHAL//if (gTTP->HistoryCur == gTTP->HistoryTop) return -1;
	//byHAL//gTTP->HistoryCur++;
	if(gTTP->HistoryCur == gTTP->HistoryTop) gTTP->HistoryCur = gTTP->HistoryBot+1; //byHAL
	else gTTP->HistoryCur++;                                                      //byHAL
	if (gTTP->HistoryCur >= HISTORYMAX) gTTP->HistoryCur -= HISTORYMAX;
	//byHAL//time = TimGetSeconds();
	time = TimDateTimeToSeconds(&(gTTP->gHWP->cDateTime)); //byHAL
	restoreHisAttr(gTTP->HistoryCur);
	if (gTTP->StopClock <= time) gTTP->StopClock = 0;
	return gTTP->History[gTTP->HistoryCur];
}

#if 0
static Int16 pushHistory(Int32 record, Int16 ins) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	Int16 pos;
	Boolean top = false;
	if (gTTP->History[ins] == record) return ins;
	if (ins == gTTP->HistoryTop) top = true;
	pos = ins + 1;
	if (pos >= HISTORYMAX) pos -= HISTORYMAX;
	if (pos == gTTP->HistoryCur) return ins;	/* overflow */
	if (top) {
		gTTP->HistoryTop = pos;
		if (gTTP->HistoryBot == pos) {
	    gTTP->HistoryBot++;	/* remove oldest */
	    if (gTTP->HistoryBot >= HISTORYMAX) gTTP->HistoryBot -= HISTORYMAX;
		}
	} else {
		if (gTTP->History[pos] != record) gTTP->HistoryTop = pos;
	}
	gTTP->History[pos] = record;
	return pos;
}

static void storeHistory(Int32 record) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	gTTP->HistoryCur = pushHistory(record, gTTP->HistoryCur);
}
#endif

Boolean setTimeTable(Int32 recordNum) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	if(loadTrainTimeDB(recordNum)) {
		if (gTTP->History[gTTP->HistoryCur] == recordNum) {
	    restoreHisAttr(gTTP->HistoryCur);
		} else {
	    //byHAL//storeHistory(recordNum);
	    gTTP->StopClock = 0;
	    unselectItem();
		}
		return true;
	}
	return false;
}


static Int16 xy2train(Int16 x, Int16 y, Boolean xyFlag) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	LineType **Lines = gTTP->CurrentTable->Lines;
	Int16 LinesLen   = gTTP->CurrentTable->LinesLen;
	Int16 hour, minute;
	if (x < 0 || y < 0) return -1;
	if (xyFlag) {
		if (LinesLen <= y || Lines[y]->length <= x) return -1;
		hour = Lines[y]->hour;
		minute = Lines[y]->items[x].minute;
	} else {
		hour = y;
		minute = x;
	}
	minute += hour * 60;
	if (hour < 24) {
		if (minute + 24 * 60 < gTTP->LastTrain) minute += 24 * 60;
	} else if (minute > gTTP->LastTrain) {
		minute -= 24 * 60;
	}
	return minute;
}

static Int16 minute2nextTrain(Int16 minute, Int16 *itemP, Int16 *lineP) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	LineType **Lines = gTTP->CurrentTable->Lines;
	Int16 LinesLen   = gTTP->CurrentTable->LinesLen;
	Int16 nextTrain;
	Int16 hour, h, i, j, fi, fj;
	hour = minute / 60;
	if (hour < 24) {
		if (minute + 24 * 60 < gTTP->LastTrain) hour += 24;
	} else if (minute >= gTTP->LastTrain) {
		hour -= 24;
	}
	minute = minute % 60;
	nextTrain = -1;
	fi = fj = -1;
	for (i=0; i < LinesLen; i++) {
		for (j=0; j < Lines[i]->length; j++) {
	    if (Lines[i]->items[j].mark != CancelMark && nextTrain < 0) {
				nextTrain = xy2train(j,i,true);
				fj = j;
				fi = i;
	    }
	    h = Lines[i]->hour;
	    if (h < Lines[0]->hour) h += 24;
	    if (hour > h) continue;
	    if (Lines[i]->items[j].mark != CancelMark
					&& (hour < h || minute < Lines[i]->items[j].minute)) {
				nextTrain = xy2train(j,i,true);
				if (nextTrain < gTTP->FirstTrain) nextTrain += 24 * 60;
				if (itemP) *itemP = j;
				if (lineP) *lineP = i;
				return nextTrain;
	    }
		}
	}
	if (itemP) *itemP = fj;
	if (lineP) *lineP = fi;
	return nextTrain;
}

static void setNextTrain(Int16 *itemP, Int16 *lineP) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	//byHAL//DateTimeType dateTime;
	//byHAL//TimSecondsToDateTime((gTTP->StopClock ? gTTP->StopClock: TimGetSeconds()),&dateTime);
	//byHAL//gTTP->NextTrain = minute2nextTrain(dateTime.hour * 60 + dateTime.minute, itemP, lineP);
	//BGN:byHAL
	if(gTTP->StopClock){
		DateTimeType dateTime;
		TimSecondsToDateTime(gTTP->StopClock, &dateTime);
		gTTP->NextTrain = minute2nextTrain(             dateTime.hour * 60 +              dateTime.minute, itemP, lineP);
	}
	else
		gTTP->NextTrain = minute2nextTrain(gTTP->gHWP->cDateTime.hour * 60 + gTTP->gHWP->cDateTime.minute, itemP, lineP);
	//END:byHAL
}

static void invertXY(Int16 x, Int16 y, CommentMarkType type) {	/* [pixel] */
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	RectangleType r;
	Int16 bottom = y + gTTP->ItemHeight - 2;
	Int16 left = x - 2;
	Int16 right = left + gTTP->ItemWidth - 1;
	switch (type) {
    case InvertMark:	/* invert block */
			r.topLeft.x = left;
			r.extent.x = gTTP->ItemWidth;
			r.topLeft.y = y;
			r.extent.y = gTTP->ItemHeight - 1;
			if(gTTP->halLayoutID != LO_TrainTime) //byHAL
				WinInvertRectangle(&r,0);
			break;
    case SuccMark:	/* succeeding point */
			WinInvertLine(left+2,bottom,left+4,bottom);
			break;
    case PrecMark:	/* preceeding point */
			WinInvertLine(right-4,bottom,right-2,bottom);
			break;
    case MiddleMark:	/* middle point */
			WinInvertLine(left+5,bottom,right-5,bottom);
			break;
    case Mark:		/* underline */
			WinInvertLine(left+2,bottom,right-2,bottom);
			break;
    case DotMark:	/* dotted underline */
			{
				CustomPatternType savePattern;
				//UInt16 dot[] = {0xAAAA, 0xAAAA, 0xAAAA, 0xAAAA};
				CustomPatternType dot[] = {{0xAA}, {0xAA}, {0xAA}, {0xAA}, {0xAA}, {0xAA}, {0xAA}, {0xAA}};
				WinGetPattern(&savePattern);
				WinSetPattern((const CustomPatternType *)dot);
				WinFillLine(left+2,bottom,right-2,bottom);
				WinSetPattern((const CustomPatternType *)&savePattern);
			}
			break;
    case DDotMark:	/* double dotted underline */
			WinInvertLine(left+2,bottom,left+4,bottom);
			WinInvertLine(right-4,bottom,right-2,bottom);
			break;
    case CancelMark:	/* cancel line */
			WinInvertLine(left,y+gTTP->ItemHeight/2-1,right,y+gTTP->ItemHeight/2-1);
			break;
    default:
			if (Mark00000 <= type && type <= Mark11111) {
				Int16 dot = gTTP->DotPattern[type-Mark00000];
				Int16 len = right - left + 1;
				Int16 pat;
				x = left;
				left = -1;
				pat = (1 << len);
				for (right=0; right <= len; right++) {
					pat >>= 1;
					if (dot & pat) {	/* pat == 0 if right == len */
						if (left < 0) left = right;
					} else {
						if (left >= 0) {
							WinInvertLine(x+left,bottom,x+right-1,bottom);
						}
						left = -1;
					}
				}
			}
	}
}

static void invertItem(Int16 item, Int16 line,	/* [cell] */
								CommentMarkType type, Boolean offs) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	Int16 x, y;
	x = item - gTTP->OfsItem;
	y = line - gTTP->OfsLine;
	if (0 <= x && 0 <= y && x < gTTP->NItems && y < gTTP->NLines) {
		x = gTTP->TableX + HourWidth(gTTP) + gTTP->ItemWidth * x + 2;
		if (offs) y = 1;
		else y = gTTP->TableY + gTTP->ItemHeight * y + 1;
		invertXY(x,y,type);
	}
}

static void drawTableLine(Int16 i) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	LineType **Lines = gTTP->CurrentTable->Lines;
	Int16 LinesLen = gTTP->CurrentTable->LinesLen;
	RectangleType r;
	Char str[3];
	Int16 hour;
	Int16 j;
	//CommentMarkType mark;
	UInt8 mark = Lines[gTTP->OfsLine]->items[gTTP->OfsItem].mark;
	WinHandle win = WinGetDrawWindow();	// save current
	FontID orgFontID; //byHAL
	if(gTTP->halLayoutID == LO_TrainTime) return; //byHAL
	orgFontID = FntSetFont(gTTP->font4table); //byHAL
	r.topLeft.x = gTTP->TableX + 1;
	r.topLeft.y = 0;
	r.extent.x = HourWidth(gTTP) + gTTP->ItemWidth * gTTP->NItems - 1;
	r.extent.y = gTTP->ItemHeight;
	WinSetDrawWindow(gTTP->OffScreen);
	WinEraseRectangle(&r,0);
	WinDrawLine(gTTP->TableX+gTTP->ItemWidth,0,gTTP->TableX+gTTP->ItemWidth,gTTP->ItemHeight);
	if (gTTP->OfsLine+i <  0 || LinesLen <= gTTP->OfsLine+i) goto copy;
	if (gTTP->OfsLine+i == 0 || Lines[gTTP->OfsLine+i-1]->hour != Lines[gTTP->OfsLine+i]->hour) {
		hour = Lines[gTTP->OfsLine+i]->hour;
		digit2str(HOUR(hour, gTTP->TwelveFlag),str,false);
		WinDrawChars(str,2,gTTP->TableX+2,1);
		if (gTTP->TwelveFlag && 12 <= hour && hour <= 23) {
	    WinDrawLine(gTTP->TableX+4,gTTP->ItemHeight-1,
									gTTP->TableX+gTTP->ItemWidth-5,gTTP->ItemHeight-1);
		}
		WinDrawLine(gTTP->TableX,0,TableRightX(gTTP),0);
	} else if (i == 0) {
		WinDrawLine(gTTP->TableX,0,TableRightX(gTTP),0);
	}
	for (j=0; j < gTTP->NItems; j++) {
		if (j >= Lines[gTTP->OfsLine+i]->length) break;
		digit2str(Lines[gTTP->OfsLine+i]->items[gTTP->OfsItem+j].minute,str,true);
		WinDrawChars(str,2,gTTP->TableX+HourWidth(gTTP)+gTTP->ItemWidth*j+2,1);
		if ((gTTP->ShowCommentsFlag || gTTP->UnderlineSpecialFlag)
				&& (mark=(UInt8)(Lines[gTTP->OfsLine+i]->items[gTTP->OfsItem+j].mark)) > (UInt8)UnMark) {
	    invertItem(gTTP->OfsItem+j, gTTP->OfsLine+i, (CommentMarkType)mark, true);
		}
	}
	if (gTTP->OfsLine+i == gTTP->SelLine) invertItem(gTTP->SelItem,gTTP->SelLine,InvertMark,true);
 copy:
	WinCopyRectangle(gTTP->OffScreen, win, &r,gTTP->TableX+1, gTTP->TableY+gTTP->ItemHeight*i, winPaint);//scrCopy);
	WinSetDrawWindow(win);	//
	FntSetFont(orgFontID); //byHAL
}

#if 0 //byHAL
static void updateTableBar(Boolean draw) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	Int16 LinesLen = gTTP->CurrentTable->LinesLen;
	//ScrollBarPtr bar;
	//bar = FrmGetObjectPtr(MainFormPtr,FrmGetObjectIndex
	//											(MainFormPtr,MainScrollBar));
	//if(LinesLen <= gTTP->NLines) {	/* no scroll bar */
	//	RectangleType r;
	//	r.topLeft.x = TableRightX(gTTP) + 1;
	//	r.topLeft.y = gTTP->TableY;
	//	r.extent.x = ScreenX - r.topLeft.x;
	//	r.extent.y = gTTP->ItemHeight * gTTP->NLines;
	//	WinEraseRectangle(&r,0);	/* erase scroll bar area */
	//	//if (bar) {
	//  //  bar->attr.usable = false;
	//	//}
	//	return;
	//}
	//if (bar) {
	if(1){
		//bar->attr.usable = true;
		if (draw) {
			Int16 old, new;
	    RectangleType r;
	    r.topLeft.x = TableRightX(gTTP) + 1;
	    r.extent.x = ScreenX - r.topLeft.x;
	    //old = bar->bounds.topLeft.y;
	    old = TimeTablePos_Y0;
	    new = gTTP->TableY + 1;
	    if (old < new) {
				r.topLeft.y = old;
				r.extent.y = new + 5 - r.topLeft.y;
				WinEraseRectangle(&r,0);
	    } else if (old > new) {
				r.topLeft.y = new;
				r.extent.y = old + 5 - r.topLeft.y;
				WinEraseRectangle(&r,0);
	    }
	    //bar->bounds.topLeft.y = new;
	    //old += bar->bounds.extent.y;
			old += MainScrollBar_Hgt;
	    new += gTTP->ItemHeight * gTTP->NLines - 2;
	    if (old < new) {
				r.topLeft.y = old - 5;
				r.extent.y = new + 2 - r.topLeft.y;
				WinEraseRectangle(&r,0);
	    } else if (old > new) {
				r.topLeft.y = new - 5;
				r.extent.y = new - r.topLeft.y;
				WinEraseRectangle(&r,0);
	   }
	    //bar->bounds.extent.y = new - bar->bounds.topLeft.y;
	    //SclSetScrollBar(bar,OfsLine,0,LinesLen-NLines,NLines);
	    //SclDrawScrollBar(bar);
		} 
		//else {
	  //  SclSetScrollBar(bar,OfsLine,0,LinesLen-NLines,NLines);
		//}
	}
}
#endif

static void scrollTable(Int16 lines) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	LineType **Lines = gTTP->CurrentTable->Lines;
	Int16 LinesLen   = gTTP->CurrentTable->LinesLen;
	RectangleType r, vacated;
	Int16 dist, from, end, i;
	//DirectionType dir;
	//WinDirectionTag dir;
	WinDirectionType dir;

	if (lines == 0 || LinesLen <= gTTP->NLines) return;
	if (lines > 0) {
		if (gTTP->OfsLine + gTTP->NLines + lines > LinesLen) {
	    lines = LinesLen - gTTP->NLines - gTTP->OfsLine;
	    if (lines == 0) return;
		}
		dir = winUp; //up;
		dist = lines;
		from = gTTP->NLines - 1 - lines;
		end = gTTP->NLines - 1;
	} else {
		if (gTTP->OfsLine + lines < 0) {
	    lines = - gTTP->OfsLine;
	    if (lines == 0) return;
		}
		dir = winDown; //down;
		dist = -lines;
		from = 0;
		end = -lines - 1;
	}
	r.topLeft.x = gTTP->TableX + 1;
	r.topLeft.y = gTTP->TableY;
	r.extent.x = HourWidth(gTTP) + gTTP->ItemWidth * gTTP->NItems - 1;
	r.extent.y = gTTP->ItemHeight * gTTP->NLines;
	gTTP->OfsLine += lines;
	if (dist < gTTP->NLines) {
		WinScrollRectangle(&r, dir, dist * gTTP->ItemHeight, &vacated);
		if (dir == winDown){ //down) {
	    if (Lines[gTTP->OfsLine+dist-1]->hour == Lines[gTTP->OfsLine+dist]->hour) {
				WinEraseLine(gTTP->TableX+1,gTTP->TableY+gTTP->ItemHeight*dist,
										 gTTP->TableX+gTTP->ItemWidth-1,gTTP->TableY+gTTP->ItemHeight*dist);
				WinEraseLine(gTTP->TableX+gTTP->ItemWidth+1,gTTP->TableY+gTTP->ItemHeight*dist,
										 TableRightX(gTTP) -1, gTTP->TableY + gTTP->ItemHeight * dist);
	    }
		} else {
	    if (gTTP->OfsLine > 0
					&& Lines[gTTP->OfsLine]->hour == Lines[gTTP->OfsLine-1]->hour)
				WinDrawLine(gTTP->TableX+1,gTTP->TableY,TableRightX(gTTP)-1,gTTP->TableY);
		}
	} else {
		from = 0;
		end = gTTP->NLines - 1;
	}
	for (i=from; i <= end; i++) drawTableLine(i);
	//updateTableBar(false);
}

static void focusItem(Int16 line, Boolean draw) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	if (line < gTTP->OfsLine || gTTP->OfsLine+gTTP->NLines-1 <= line) {
		if(draw){
	    scrollTable(line - gTTP->OfsLine - gTTP->NLines/3);
		} else {
	    gTTP->OfsLine = line - gTTP->NLines/3;
	    if (gTTP->OfsLine < 0) gTTP->OfsLine = 0;
	    else if (gTTP->OfsLine + gTTP->NLines > gTTP->CurrentTable->LinesLen) {
				gTTP->OfsLine = gTTP->CurrentTable->LinesLen - gTTP->NLines;
				if (gTTP->OfsLine < 0) gTTP->OfsLine = 0;
	    }
		}
	}
}

static void selectCurrent(Boolean notes, Boolean draw) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	Int16 item, line;
	setNextTrain(&item,&line);
	focusItem(line,draw);
	gTTP->SelectTrain = gTTP->NextTrain;
	if (draw) {
		selectItem(item,line,notes);
	} else {
		gTTP->SelItem = item;
		gTTP->SelLine = line;
	}
	gTTP->ManualSelectFlag = false;	/* automatically selected */
}

static void drawAlarm(void) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	BitmapPtr p;
	if (!gTTP->AlarmBitmap) return;
	if (gTTP->AlarmMinute >= 0) {
		p = MemHandleLock(gTTP->AlarmBitmap);
		WinDrawBitmap(p,gTTP->AlarmRect.topLeft.x,gTTP->AlarmRect.topLeft.y);
		MemHandleUnlock(gTTP->AlarmBitmap);
	} else {
		//byHAL//WinEraseRectangle(&(gTTP->AlarmRect),0); //^Cgo[̉Eォ炿ƍ̂Ƃ
	}
}

static void drawBitmap(Int16 num, Int16 x, Int16 y) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	BitmapPtr p;
	p = MemHandleLock(gTTP->NumBitmap[num]);
	WinDrawBitmap(p,x,y);
	MemHandleUnlock(gTTP->NumBitmap[num]);
}

//BGN:byHAL
static Boolean drawLargeClock(Int16 min, Boolean minus){ //, Boolean isTrnTimMode){ 
	Int16 hour, cx = XPosRight, cy = LargeClockY;
	Boolean colon = false;
	if(min < 0){ min = -1 * min -1; minus = true; }
	if(min >= 60) colon = true;
	hour = min / 60;
	min %= 60;
	;                                         cx -= NumBitmapX  ; drawBitmap( min%10, cx, cy);   //   hh:m[m]
	if(hour    > 0 || min/10  > 0 || !minus){ cx -= NumBitmapX  ; drawBitmap( min/10, cx, cy); } //   hh:[m]m
	if(hour    > 0                || !minus){ cx -= ColonBitmapX; drawBitmap(     10, cx, cy); } //  hh[:]mm
	if(hour    > 0                         ){ cx -= NumBitmapX  ; drawBitmap(hour%10, cx, cy); } // h[h]:mm
	if(hour/10 > 0                         ){ cx -= NumBitmapX  ; drawBitmap(hour/10, cx, cy); } // [h]h:mm
	if(                               minus){ cx -= NumBitmapX  ; drawBitmap(     11, cx, cy); } //[-]hh:mm
	if(hour <= 0){
		cx -= NumBitmapX/2; //RgƋ߂̂ŌԂ
		{
			RectangleType rct = { { cx, cy }, { NumBitmapX/2, NumBitmapY } };//RgƋ߂̂ŌԂ
			WinEraseRectangle(&rct, 0); 
		}
	}
	{
		RectangleType rct = { { cx, cy }, { XPosRight-cx+1, NumBitmapY+1 } };
		WinDrawRectangleFrame(simpleFrame, &rct);
	}
	return colon;
}

#define TableRightPosPlus  7
#define TableRightPosPlusT 3
static void drawTrainTimeClock(Int16 min, Boolean minus){
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	FontID orgFontID;
	Char cStr[16];
	Int16 hour, bmpX, cx, cy;
	//RectangleType rct = { { TimeTablePos_X0, TimeTablePos_Y0 }, { TimeTablePos_Wid+TableRightPosPlus, TableBottomY(gTTP)-TimeTablePos_Y0 } };
	RectangleType rct = { { gTTP->TableX, gTTP->TableY }, { TimeTablePos_Wid+TableRightPosPlus, TableBottomY(gTTP)-gTTP->TableY } };

	if(min < 0){ min = -1 * min -1; minus = true; }
	hour = min / 60;
	min %= 60;

	//--- g
	WinEraseRectangle(&rct, 0);
	WinDrawLine(rct.topLeft.x, rct.topLeft.y               , rct.topLeft.x + rct.extent.x, rct.topLeft.y               );
	WinDrawLine(rct.topLeft.x, rct.topLeft.y + rct.extent.y, rct.topLeft.x + rct.extent.x, rct.topLeft.y + rct.extent.y);
	
	//--- rbg}bv̉E[ʒu
	bmpX = TimeTablePos_X0;                  bmpX += NumBitmapX  ; //   hh:m[m]
	if(hour    > 0 || min/10  > 0 || !minus) bmpX += NumBitmapX  ; //   hh:[m]m
	if(hour    > 0                || !minus) bmpX += ColonBitmapX; //  hh[:]mm
	if(hour    > 0                         ) bmpX += NumBitmapX  ; // h[h]:mm
	if(hour/10 > 0                         ) bmpX += NumBitmapX  ; // [h]h:mm
	if(                               minus) bmpX += NumBitmapX  ; //[-]hh:mm
	if(hour <= 0)                            bmpX += 10; //Pʂ̎͏Ԃ󂯂

	//--- ݎ
	//- t
	orgFontID = FntSetFont(FossilLargeFont);
	cy = rct.topLeft.y + 2;
	{
		MemHandle mhStr = DmGet1Resource('tSTR', SrID_WD0 + gTTP->gHWP->cDateTime.weekDay);
		if(mhStr != NULL){
			Char    *pStr = (Char*)MemHandleLock(mhStr);
			if(pStr != NULL) StrPrintF(cStr, "%d/%d %s", gTTP->gHWP->cDateTime.month, gTTP->gHWP->cDateTime.day, pStr);
			else             StrPrintF(cStr, "%d/%d"   , gTTP->gHWP->cDateTime.month, gTTP->gHWP->cDateTime.day      );
			MemHandleUnlock(mhStr);
		}else{
			StrPrintF(cStr, "%d/%d", gTTP->gHWP->cDateTime.month, gTTP->gHWP->cDateTime.day);
		}
		DmReleaseResource(mhStr);
		cx = TableRightX(gTTP) - FntCharsWidth(cStr, StrLen(cStr)) + TableRightPosPlusT;
		if(cx < bmpX){ //rbg}bvƏdȂ悤Ȃ  j\
			StrPrintF(cStr, "%d/%d", gTTP->gHWP->cDateTime.month, gTTP->gHWP->cDateTime.day);
			cx = TableRightX(gTTP) - FntCharsWidth(cStr, StrLen(cStr)) + TableRightPosPlusT;
			if(cx < bmpX){ //rbg}bvƏdȂ悤Ȃ  tHg
				FntSetFont(largeFont    ); cx = TableRightX(gTTP) - FntCharsWidth(cStr, StrLen(cStr)) + TableRightPosPlusT;
				if(cx < bmpX){
					FntSetFont(stdFont    ); cx = TableRightX(gTTP) - FntCharsWidth(cStr, StrLen(cStr)) + TableRightPosPlusT;
				}
			}
		}
		WinDrawChars(cStr, StrLen(cStr), cx, cy);
	}
	cy += FntCharHeight();// + 2;
	//- 
	{
		Char strHour[3], strColon[] = ":", strMin[3];
		StrPrintF(strHour,   "%d", gTTP->gHWP->cDateTime.hour  );
		StrPrintF(strMin , "%02d", gTTP->gHWP->cDateTime.minute);
		//-FossilLEDFont+FossilLargeBoldFont
		cx = TableRightX(gTTP) + TableRightPosPlusT;
		FntSetFont(FossilLargeBoldFont); cx -= FntCharsWidth(strColon, StrLen(strColon));
		FntSetFont(FossilLedFont      ); cx -= FntCharsWidth(strHour , StrLen(strHour )) + FntCharsWidth(strMin, StrLen(strMin)) +3;
		if(cx > bmpX){ //rbg}bvƏdȂȂ΂̂܂ܕ`
			cy = TableBottomY(gTTP) - FntCharHeight() - 1;
			cx = TableRightX(gTTP)+TableRightPosPlusT;
			FntSetFont(FossilLedFont      ); cx -= FntCharsWidth(strMin  , StrLen(strMin  ))  ; WinDrawChars(strMin  , StrLen(strMin  ), cx, cy  );
			FntSetFont(FossilLargeBoldFont); cx -= FntCharsWidth(strColon, StrLen(strColon))+1; WinDrawChars(strColon, StrLen(strColon), cx, cy+2);
			FntSetFont(FossilLedFont      ); cx -= FntCharsWidth(strHour , StrLen(strHour ))+2; WinDrawChars(strHour , StrLen(strHour ), cx, cy  );
		}
		else{ //rbg}bvƏdȂ悤Ȃ珬tHg
			StrPrintF(cStr, "%d:%02d", gTTP->gHWP->cDateTime.hour, gTTP->gHWP->cDateTime.minute);
			FntSetFont(FossilLargeFont); cx = TableRightX(gTTP)-FntCharsWidth(cStr, StrLen(cStr))+TableRightPosPlusT;
			if(cx < bmpX){
				FntSetFont(largeFont    ); cx = TableRightX(gTTP)-FntCharsWidth(cStr, StrLen(cStr))+TableRightPosPlusT;
				if(cx < bmpX){
					FntSetFont(stdFont    ); cx = TableRightX(gTTP)-FntCharsWidth(cStr, StrLen(cStr))+TableRightPosPlusT;
				}
			}
			cy += (TableBottomY(gTTP)-cy)/2 - FntCharHeight()/2;
			WinDrawChars(cStr, StrLen(cStr), cx, cy);
		}					
	}

	//--- c莞ԁFrbg}bv
	//WinDrawLine((bmpX+cx)/2, TimeTablePos_Y0+2, (bmpX+cx)/2, TableBottomY(gTTP)-2)
	cy = rct.topLeft.y + (TableBottomY(gTTP) - rct.topLeft.y - NumBitmapY)/2 + 2;
	;                                         bmpX -= NumBitmapX  ; drawBitmap( min%10, bmpX, cy);   //   hh:m[m]
	if(hour    > 0 || min/10  > 0 || !minus){ bmpX -= NumBitmapX  ; drawBitmap( min/10, bmpX, cy); } //   hh:[m]m
	if(hour    > 0                || !minus){ bmpX -= ColonBitmapX; drawBitmap(     10, bmpX, cy); } //  hh[:]mm
	if(hour    > 0                         ){ bmpX -= NumBitmapX  ; drawBitmap(hour%10, bmpX, cy); } // h[h]:mm
	if(hour/10 > 0                         ){ bmpX -= NumBitmapX  ; drawBitmap(hour/10, bmpX, cy); } // [h]h:mm
	if(                               minus){ bmpX -= NumBitmapX  ; drawBitmap(     11, bmpX, cy); } //[-]hh:mm

	//---
	FntSetFont(orgFontID);
}

//END:byHAL

#if 0 //byHAL
static Boolean drawLargeClock(Int16 min, Int16 sec) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	RectangleType r;
	Boolean minus;
	Boolean colon = false;
	if (min - 24 * 60 > LargeClockMin
			|| (min - 24 * 60 == LargeClockMin && sec > 0)) min -= 24 * 60;
	if (min < 0) {
		minus = true;
		min = -min;
		if (sec > 0) {
	    sec = 60 - sec;
	    min--;
		}
		if (min >= 10) {	/* >= 10min */
	    sec = min % 60;
	    min = min / 60;
	    colon = true;
		}
	} else {
		minus = false;
		if (min >= 60) {	/* >= 1hour */
	    sec = min % 60;
	    min = min / 60;
	    colon = true;
		}
	}
	//BGN:byHAL
	if(sec == 0 && !minus) min--; // ROb͂Qƕ\
	sec = min % 60; // xx:yy  yy ɕ\i{͕bj
	min = min / 60; // xx:yy  xx Ɏ\i{͕j
	//END:byHAL
	r.topLeft.x = LargeClockX;
	r.topLeft.y = ScreenY - CommentsHeight(gTTP) * LargeClockLines(gTTP);
	r.extent.x = ScreenX - r.topLeft.x;
	r.extent.y = LargeClockY - r.topLeft.y;

	//byHAL//WinEraseRectangle(&r,0);
	//byHAL//if (minus) drawBitmap(11,LargeClockX,LargeClockY);
	//byHAL//else drawBitmap(min/10,LargeClockX,LargeClockY);
	//byHAL//drawBitmap(min%10,LargeClockX+NumBitmapX,LargeClockY);
	//byHAL//drawBitmap(10,LargeClockX+NumBitmapX*2,LargeClockY);
	//byHAL//drawBitmap(sec/10,LargeClockX+NumBitmapX*2+ColonBitmapX,LargeClockY);
	//byHAL//drawBitmap(sec%10,LargeClockX+NumBitmapX*3+ColonBitmapX,LargeClockY);

	//BGN:byHAL
	//WinEraseRectangle(&r,0);
	{ 
		Int16 cx;
		cx = 159;                     cx -= NumBitmapX  ; drawBitmap(sec%10, cx, LargeClockY);   //   hh:m[m]
/*if(sec/10 > 0 || min    > 0)*/{ cx -= NumBitmapX  ; drawBitmap(sec/10, cx, LargeClockY); } //   hh:[m]m
/*if(              min    > 0)*/{ cx -= ColonBitmapX; drawBitmap(    10, cx, LargeClockY); } //  hh[:]mm
		if(              min    > 0){ cx -= NumBitmapX  ; drawBitmap(min%10, cx, LargeClockY); } // h[h]:mm
		if(              min/10 > 0){ cx -= NumBitmapX  ; drawBitmap(min/10, cx, LargeClockY); } // [h]h:mm
		if(minus                   ){ cx -= NumBitmapX  ; drawBitmap(    11, cx, LargeClockY); } //[-]hh:mm
	}
	//END:byHAL

	return colon;
}
#endif

/*static*/ void drawTime(Boolean draw) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	//byHAL//static Int16 prevSelectTrain;
	static Boolean prevLargeClockFlag;
	static Boolean prevScreenFlag;
	static UInt32 prevTick;
	static Boolean smallColon;
	static Boolean largeColon;
	static Int16 prevAlarmMinute;
	UInt32 time;
	UInt32 tick;
	WinHandle win, swin;
	RectangleType r;
	Int16 current, min, sec;
	Char str[16]; 
	DateTimeType dateTime;
	Boolean screenFlag = true; //!menuAppear();
	if (screenFlag && gTTP->AlarmMinute != prevAlarmMinute && gTTP->AlarmTapCount <= 0) {
		drawAlarm();
		prevAlarmMinute = gTTP->AlarmMinute;
	}
	//byHAL//time = TimGetSeconds();
	time = TimDateTimeToSeconds(&(gTTP->gHWP->cDateTime)); //byHAL
	tick = TimGetTicks();
	if (gTTP->StopClock) {
		if (time < gTTP->StopClock) {
	    time = gTTP->StopClock;
		} else {
	    gTTP->StopClock = 0;
	    gTTP->DrawNotesFlag = true;	/* redraw comments area */
		}
	}
	if (screenFlag && !gTTP->AlarmDialogFlag && gTTP->DrawNotesFlag) {
		selectItem(-1,-1,true);
		gTTP->DrawNotesFlag = false;
	}
	if (prevTick && tick - prevTick > gTTP->TicksPerSeconds/3) {
		prevTick = 0;
//#if 1 //byHAL
		if (smallColon && screenFlag && gTTP->AlarmTapCount == 0) {
	    r.topLeft.x = gTTP->TimeLeftColonX;
	    r.topLeft.y = gTTP->TimeY;
	    r.extent.x = gTTP->BoldColonWidth;
	    r.extent.y = gTTP->TimeHeight;
	    WinEraseRectangle(&r,0); 
		}
		if (largeColon && screenFlag && isLargeClockShown()) {
	    r.topLeft.x = LargeClockX+NumBitmapX*2;
	    r.topLeft.y = LargeClockY;
	    r.extent.x = ColonBitmapX;
	    r.extent.y = ScreenY - LargeClockY;
	    WinEraseRectangle(&r,0); 
		}
//#endif
	}
	if (!draw && time == gTTP->PrevTime
			&& gTTP->prevSelectTrain == gTTP->SelectTrain
			&& prevLargeClockFlag == gTTP->LargeClockFlag
			&& prevScreenFlag == screenFlag) return;
	if (time - gTTP->PrevTime > 2) {	/* powered off ? */
		gTTP->LastSec = time;
	}
	gTTP->PrevTime = time;
	gTTP->prevSelectTrain = gTTP->SelectTrain;
	prevLargeClockFlag = gTTP->LargeClockFlag;
	prevScreenFlag = screenFlag;
	prevTick = tick;
	smallColon = largeColon = false;
	//byHAL//TimSecondsToDateTime(time,&dateTime);
	dateTime = gTTP->gHWP->cDateTime; //byHAL
	min = dateTime.hour * 60 + dateTime.minute;
	if (gTTP->AlarmMinute >= 0) {
		gTTP->AlarmMinuteSave = gTTP->AlarmMinute;
		min -= gTTP->AlarmMinute;
		if (min < 0) min += 24 * 60;
		if (dateTime.second % (min+1) == 0) gTTP->AlarmMinute = getAlarm();
		if (screenFlag
				&& gTTP->AlarmMinute != prevAlarmMinute && gTTP->AlarmTapCount <= 0) {
	    drawAlarm();
	    prevAlarmMinute = gTTP->AlarmMinute;
		}
	} else if (gTTP->AlarmMinuteSave >= 0) {
		min -= gTTP->AlarmMinuteSave;
		if (min < 0) min += 24 * 60;
		if (min <= (24 * 60 - AlarmMinuteMax)) gTTP->AlarmMinuteSave = -1;
	}
	win = WinGetDrawWindow();	/* save current */
	swin = WinGetDisplayWindow();
	WinSetDrawWindow(swin);
	/*  StrPrintF(str,"%02d:%02d:%02d",
			dateTime.hour,dateTime.minute,dateTime.second);	*/
	// Ěݎ
#if 0 //byHAL
	digit2str(HOUR(dateTime.hour, gTTP->TwelveFlag), str, true);
	str[2] = ':';
	digit2str(dateTime.minute,&str[3],true);
	str[5] = ':';
	digit2str(dateTime.second,&str[6],true);
	r.topLeft.x = gTTP->TimeX;
	r.topLeft.y = gTTP->TimeY;
	r.extent.x = gTTP->TimeWidth;
	r.extent.y = gTTP->TimeHeight;
	if (gTTP->ClockInvertedFlag) {
		const CustomPatternType BlackPattern[] = {{0xFF},{0xFF}, {0xFF},{0xFF}, {0xFF},{0xFF}, {0xFF},{0xFF}};
		CustomPatternType savePattern;
		WinGetPattern(&savePattern);
		WinSetPattern((const CustomPatternType *)BlackPattern);
		WinFillRectangle(&r,0); 
		WinSetPattern((const CustomPatternType *)&savePattern);
		WinInvertChars(str,StrLen(str),gTTP->TimeX,gTTP->TimeY);
	} else {
		WinEraseRectangle(&r,0); 
		WinDrawChars(str,StrLen(str),gTTP->TimeX,gTTP->TimeY);
	}
#endif //byHAL
	current = xy2train(dateTime.minute,dateTime.hour,false);
	if (screenFlag
			&& (gTTP->NextTrain <= current
					|| current == gTTP->LastTrain
					|| (current <= gTTP->FirstTrain && gTTP->FirstTrain < gTTP->NextTrain))) {
		if (!gTTP->SelectCurrentFlag) {
	    if (gTTP->ManualSelectFlag || gTTP->AlarmDialogFlag) {
				setNextTrain(NULL,NULL);
	    } else {
				gTTP->SelectCurrentFlag = true;
				selectCurrent(false,true);	/* don't draw notes */
				gTTP->DrawNotesFlag = true;
	    }
		}
	}
	else gTTP->SelectCurrentFlag = false;

	min = gTTP->NextTrain - current;
	if (min < 0) min += 24 * 60;
	else if (min > 24*60) min -= 24 * 60;
	if (dateTime.second > 0) {
		min--;
		sec = 60 - dateTime.second;
	} else sec = 0;
	if (screenFlag && gTTP->AlarmTapCount > 0) {
		gTTP->AlarmTapCount--;
		if (gTTP->AlarmTapCount == 0) {
	    drawAlarm();
	    //byHAL//WinEraseRectangle(&(gTTP->NormalClockRect),0); 
		}
	}
#if 0 //byHAL
	if (gTTP->AlarmTapCount == 0) {
		// 㕔̎c莞ԕ\H
		if (min < 60) {		/* < 1hour */
	    /*	    	StrPrintF(str,"%02d:%02d",min,sec);	*/
	    digit2str(min,str,true);
	    str[2] = '.';
	    digit2str(sec,&str[3],true);
		} else {		/* > 1hour */
	    digit2str(min/60,str,true);
	    str[2] = '.';
	    digit2str(min%60,&str[3],true);
	    smallColon = true;
		}
		FntSetFont(boldFont);
		WinDrawChars(str,StrLen(str),gTTP->TimeLeftX,gTTP->TimeY);
		FntSetFont(stdFont);
	}
#endif //byHAL
	min = gTTP->SelectTrain - current;
	if (min < 0) min += 24 * 60;
	else if (min > 24*60) min -= 24 * 60;
	if (dateTime.second > 0) min--;
	//BGN:byHAL
	if(gTTP->halLayoutID != LO_TrainTime){
		Boolean minus = (min < 0 || (min == 0 && sec == 0));
		Int16 min1 = (sec == 0 && !minus) ? min - 1 : min;
		if(min1 - 24 * 60 > LargeClockMin	|| (min1 - 24 * 60 == LargeClockMin && sec > 0)) min1 -= 24 * 60;
		//-
		if(min1 >= 0 && min < 60) FntSetFont(FossilLargeBoldFont); //gTTP->font4CTime);
		else                      FntSetFont(FossilLargeFont    ); //gTTP->font4NoteTop);
		r.topLeft.x = XPosLeft;
		r.topLeft.y = YPosBottom - FntCharHeight()+1;
		r.extent.x  = ScreenX - XPosLeft;
		r.extent.y  = FntCharHeight();
		WinEraseRectangle(&r,0); WinDrawRectangleFrame(simpleFrame, &r);
		if(min1 >= 0 && min < 600){
			MemHandle mhStr = DmGet1Resource('tSTR', SrID_IdxNow);
			if(mhStr != NULL){
				Char    *pStr = (Char*)MemHandleLock(mhStr);
				if(pStr != NULL) StrPrintF(str,"%s %d:%02d", pStr, dateTime.hour, dateTime.minute);
				else             StrPrintF(str,   "%d:%02d",       dateTime.hour, dateTime.minute);
				MemHandleUnlock(mhStr);
			}
			DmReleaseResource(mhStr);
		}else{
			StrPrintF(str,   "%d:%02d", dateTime.hour, dateTime.minute);
		}
		WinDrawChars(str, StrLen(str), r.topLeft.x, r.topLeft.y);
		if(screenFlag){
			if(isLargeClockShown()) {
				largeColon = drawLargeClock(min1, minus);
			}else{
				MemHandle mhStr = DmGet1Resource('tSTR', SrID_IdxRem);
				Char      *pStr = (mhStr) ? (Char*)MemHandleLock(mhStr) : (Char*)NULL;
				if(     min1 <= -60) StrPrintF(str,  " %d:%02d ",                          min1/60, -1*(min1%60)-1);
				else if(min1 <    0) StrPrintF(str,     " - %d ",                                   -1*(min1   )-1);
				else if(      minus) StrPrintF(str,     " - %d ",                                       min1      );
				else if(min1 <   60) StrPrintF(str,  "%s :%02d ", ((pStr) ? pStr : "Rem"),              min1      );
				else                 StrPrintF(str,"%s %d:%02d ", ((pStr) ? pStr : "Rem"), min1/60,     min1%60   );
				WinDrawChars(str, StrLen(str), XPosRight - FntCharsWidth(str, StrLen(str)),  r.topLeft.y);
				if(mhStr != NULL) MemHandleUnlock(mhStr);
				DmReleaseResource(mhStr);
			}
		}
	}
	else{ //(gTTP->halLayoutID == LO_TrainTime)
		Boolean minus = (min < 0 || (min == 0 && sec == 0));
		Int16 min1 = (sec == 0 && !minus) ? min - 1 : min;
		if(min1 - 24 * 60 > LargeClockMin	|| (min1 - 24 * 60 == LargeClockMin && sec > 0)) min1 -= 24 * 60;
		drawTrainTimeClock(min1, minus);
	}
	FntSetFont(gTTP->font4Note);
	//END:byHAL
	//byHAL//if (screenFlag && isLargeClockShown()) {
	//byHAL//	largeColon = drawLargeClock(min,sec);
	//byHAL//}
	WinSetDrawWindow(win);	/* restore */
	//drawBatt(); //byHAL
}

static void drawTableTime(void) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	Int16 i;
	if(gTTP->halLayoutID == LO_TrainTime) return; //byHAL
	for (i=0; i < gTTP->NLines; i++) drawTableLine(i);
	WinDrawLine(gTTP->TableX,gTTP->TableY+gTTP->ItemHeight*i,
							TableRightX(gTTP),gTTP->TableY+gTTP->ItemHeight*i);
}

/*static*/ void drawBatt(void){ //byHAL obeCWP[^BXN[o[̏ꏊɕ`Ă݂B
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	//RectangleType rct = { {MainScrollBar_X0 , MainScrollBar_Y0 }, {MainScrollBar_Wid, MainScrollBar_Hgt} };
	RectangleType rct = { {TableRightX(gTTP) + 8, gTTP->TableY + 1}, {ScreenX, TableBottomY(gTTP)} };
	UInt16 barLen;
	int cLine;
	rct.extent.x -= rct.topLeft.x + 3;
	rct.extent.y -= rct.topLeft.y;
	barLen = ((rct.extent.y-3)*(gTTP->gHWP->percentBattery))/(100);
	WinDrawRectangleFrame(simpleFrame, &rct);
	if(barLen > 0)
		for(cLine=rct.topLeft.x+1; cLine<rct.topLeft.x+rct.extent.x-1; cLine++)
			WinDrawLine( cLine, rct.topLeft.y+rct.extent.y-2, cLine, rct.topLeft.y+rct.extent.y-2-barLen);
}

/*static*/ void drawTable(void) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();

	LineType **Lines = gTTP->CurrentTable->Lines;
	Int16 LinesLen = gTTP->CurrentTable->LinesLen;
	Int16 width, len;
	Int16 item, line;
	Boolean ok;
	RectangleType rct;
	//--- draw title
	FntSetFont(gTTP->font4Title);  //byHAL
	width = ScreenX - gTTP->TableX;
	rct.topLeft.x = gTTP->TableX;
	//byHAL//rct.topLeft.y = gTTP->TopY - gTTP->ItemHeight; 
	rct.topLeft.y = 1; //byHAL
	rct.extent.x = width;
	rct.extent.y = gTTP->ItemHeight;
	//byHAL//if(gTTP->NarrowMode >= 0){ gTTP->TableY = gTTP->TopY + gTTP->ItemHeight; }
	//BGN:byHAL
	if(gTTP->NarrowMode >= 0) {
		FontID orgFontID = FntSetFont(gTTP->font4Note);
		gTTP->TableY = gTTP->TopY + FntCharHeight() + 1;
		rct.extent.y -= FntCharHeight() + 1;
		FntSetFont(orgFontID);
	}
	//END:byHAL
	else{ gTTP->TableY = gTTP->TopY                   ; }
	rct.extent.y = gTTP->TableY - rct.topLeft.y;
	WinEraseRectangle(&rct, 0);	/* erase Title area */ 
	len = StrLen(gTTP->Title);
	ok = true;
	FntCharsInWidth(gTTP->Title, &width, &len, &ok);
	WinDrawChars(gTTP->Title, len, rct.topLeft.x, rct.topLeft.y);
	//--- draw table 㔼̂邶Ђ傤
	if(gTTP->halLayoutID != LO_TrainTime){ //byHAL
		FntSetFont(gTTP->font4table); //byHAL
		//setupNarrowPopup(MainFormPtr);
		WinDrawLine(gTTP->TableX, gTTP->TableY, gTTP->TableX, TableBottomY(gTTP));
		WinDrawLine(TableRightX(gTTP),gTTP->TableY,
								TableRightX(gTTP),TableBottomY(gTTP));
		rct.topLeft.x = gTTP->TableX;
		rct.topLeft.y = TableBottomY(gTTP) + 1;
		rct.extent.x = ScreenX - rct.topLeft.x;
		rct.extent.y = commentY(0, gTTP, false) - rct.topLeft.y;
		WinEraseRectangle(&rct,0);	/* beneath table */
	} //byHAL
	gTTP->OfsLine = 0;
	gTTP->OfsItem = 0;
	if (0 <= gTTP->SelItem && 0 <= gTTP->SelLine) {
		if (LinesLen <= gTTP->SelLine
				|| Lines[gTTP->SelLine]->length <= gTTP->SelItem) {
			unselectItem();
		}
		//BGN:byHAL 
		else if(!gTTP->ManualSelectFlag)
			unselectItem(); //悭񂪁CunselectȂƎԂ̕\؂ւ܂Ȃ
		//END:byHAL
	}
	else{
		unselectItem();
	}
	
	item = gTTP->SelItem;
	line = gTTP->SelLine;
	selectCurrent(false,false);	/* don't draw */
	if (0 <= item && 0 <= line) {
		gTTP->ManualSelectFlag = true;	/* manually selected */ 
		selectItem(item,line,false);
		focusItem(gTTP->SelLine,false);
	}
	if(gTTP->halLayoutID != LO_TrainTime) //byHAL
		drawTableTime();
	//--- draw note ̗ԂƂ̃Rg^
	drawTime(false);
	gTTP->DrawNotesFlag = true;	/* redraw comments area */
	drawTime(true);
	//updateTableBar(true);
	/* upper split bar */
	//WinDrawLine(ScreenX-7,TableBottomY(gTTP),ScreenX-1,TableBottomY(gTTP));
	//if (gTTP->ShowArrivesFlag && gTTP->CurrentTable->ArrivesLen > 0) updateArriveBar(true);
	drawAlarm();
	drawBatt(); //byHAL
}

//FileMenuType *getFileMenuItem(UInt32 now, Int16 item) {
static FileMenuType *getFileMenuItem(Int16 item) {
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	Int16 offset = 0;
	if (gTTP->BorderMin == -2) {
		offset = MENU_NITEMS;
	} else if (gTTP->BorderMin >= 0) {
		//DateTimeType dateTime;
		//TimSecondsToDateTime(now,&dateTime);
		if (gTTP->gHWP->cDateTime.hour <= MidNight	/* till 4:00 */
				|| gTTP->BorderMin <= gTTP->gHWP->cDateTime.hour * 60 + gTTP->gHWP->cDateTime.minute)
	    offset = MENU_NITEMS;
	}
	return &(gTTP->FileMenu[offset+item]);
}

//Table.c  MainFormHandleEvent() ̒ switch (e->eType) { case frmOpenEvent: ̕
Boolean frmOpenEvent_MainFormHandleEvent(void){ 
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();

	//FormPtr form = gTTP->MainFormPtr;
	//gTTP->MainFormPtr = FrmGetFormPtr(MainForm);
	if(1){//if(gTTP->MainFormPtr){
		openTable();
		if((gTTP->ChooseStartupFlag && gTTP->StartupFlag                         ) ||
			 (gTTP->TrainTimeRecordNum < 0                                         ) ||
			 (gTTP->CurrentTable == NULL && !setTimeTable(gTTP->TrainTimeRecordNum))    ){
			//byHAL//FrmGotoForm(TableListForm);
			//BGN:byHAL
			gTTP->StartupFlag = false;
			gTTP->isNoData = true;
			return false;
			//END:byHAL
		} else {
			//FrmDrawForm(MainFormPtr);
			//updateHistoryButton();
			drawTable();
		}
		//if (form) FrmDeleteForm(form);
		//handled = true;
	}
	//else {
	//	gTTP->MainFormPtr = form;
	//}
	gTTP->StartupFlag = false;
	gTTP->isNoData = false;
	return true;
}


//Table.c  MainFormHandleEvent() ̒ switch (e->eType) { case ctlSelectEvent: switch(e->data.ctlSelect.controlID) { case MainBackward:  case MainForward: ̕
void ctlSelectEvent_MainForwardBackward_MainFormHandleEvent(Boolean isBackward){ 
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	Int32 record;

	putLRU();
	//saveHisAttr(gTTP->HistoryCur);
	gTTP->isNarrowModeInvert = false;
	record = (isBackward) ? backHistory() : forwardHistory();
	if (record < 0) return;
	if(loadTrainTimeDB(record)){
		//updateHistoryButton();
		//drawTable(); //myMain() Ŏs
	}
	//- G[
	else if(isBackward){
		gTTP->HistoryBot = gTTP->HistoryCur;	/* dispose bad DB */
		forwardHistory();
		//updateHistoryButton();
	}
	else{
		backHistory();
		gTTP->HistoryTop = gTTP->HistoryCur;	/* dispose bad DB */
		//updateHistoryButton();
	}
}


//Table.c  MainFormHandleEvent() ̒ switch (e->eType) { case menuEvent: switch(e->data.menu.itemID) { case FileMenuOne: ̕
void menuEvent_FileMenuOneToEight_MainFormHandleEvent(Boolean isBackward){ 
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();
	FileMenuType *menu;
	//Int32 record;
	UInt8 nLoop;

	//WinEraseWindow();
	//- switch (e->eType) { case menuEvent: switch(e->data.menu.itemID) { case FileMenuOne: ...
	//menu = getFileMenuItem(now,item);
	//if (menu->recordNum < 0) break;
	if(gTTP->cFileMenuItemID < 1 || gTTP->cFileMenuItemID > MENU_NITEMS) 
		gTTP->cFileMenuItemID = 0;
	nLoop = 0;
	do{
		if(isBackward) gTTP->cFileMenuItemID = (gTTP->cFileMenuItemID > 1          ) ? gTTP->cFileMenuItemID-1 : MENU_NITEMS;
		else           gTTP->cFileMenuItemID = (gTTP->cFileMenuItemID < MENU_NITEMS) ? gTTP->cFileMenuItemID+1 : 1          ;
		menu = getFileMenuItem(gTTP->cFileMenuItemID-1);
		//menu = &(gTTP->FileMenu[gTTP->cFileMenuItemID-1]); //AM/PMŃXg؂ւȂ΁C̍s̏ł
		nLoop++;
	}while(menu->recordNum < 0 && nLoop < MENU_NITEMS);

	if (menu->recordNum < 0){
		gTTP->cFileMenuItemID = -1;
		return;
	}
	
	if (!checkTitle(menu->recordNum, menu->str)) {
		menu->recordNum = searchFile(menu->str); //record = searchFile(menu->str);
		if(menu->recordNum){ //if (record < 0) {
			//setFileMenuItem(now,item,"",0,-1);
			return; //break;
		}
		//setFileMenuItem(now,item,NULL,0,record);
	}

	putLRU();
	//saveHisAttr(HistoryCur);
	gTTP->isNarrowModeInvert = false;
	if (loadTrainTimeDB(menu->recordNum)) {
		//storeHistory(menu->recordNum);
		gTTP->StopClock = 0;
		unselectItem();
	//load:
		//updateHistoryButton();
		//drawTable(); //myMain() Ŏs
	}
}

//Table.c  MainFormHandleEvent() ̒ switch (e->eType) { case menuEvent: switch(e->data.menu.itemID) { case OptionsMenuNarrow: ̕
void menuEvent_OptionsMenuNarrow_MainFormHandleEvent(){
	TimeTableGlobals_t* gTTP = getPtrTimeTableGlobals();

	gTTP->isNarrowModeInvert = !(gTTP->isNarrowModeInvert);

	putLRU();
	//setTimeTable(gTTP->TrainTimeRecordNum); //->loadTrainTimeDB()->set value gTTP->NarrowMode based on gTTP->isNarrowModeInvert
	loadTrainTimeDB(gTTP->TrainTimeRecordNum); //->set value gTTP->NarrowMode based on gTTP->isNarrowModeInvert
	//if(!gTTP->ManualSelectFlag) unselectItem(); //l胂[hςƗԃXg̔ԍς̂ŁCꗥɎI[hɈڍs
	unselectItem();

	gTTP->DrawNotesFlag = true; //myMain()drawTime(true)s邽

	//drawTable();    //myMain() Ŏs
	//drawTime(true); //myMain() Ŏs

	/*
	if (gTTP->NarrowMode < 0) {
		gTTP->NarrowMode = -(gTTP->NarrowMode) - 1;
		if (gTTP->NarrowMode >= gTTP->CurrentTable->NarrowsLen) gTTP->NarrowMode = 0;
		if (gTTP->NarrowMode > 0) {
			putLRU();
			loadTrainTimeDB(gTTP->TrainTimeRecordNum);
			unselectItem();
		}
		gTTP->NLines--;
		gTTP->TableY = gTTP->TopY + gTTP->ItemHeight;
	} else {
		if (gTTP->NarrowMode > 0) {
			gTTP->NarrowMode = -(gTTP->NarrowMode) - 1;
			putLRU();
			loadTrainTimeDB(gTTP->TrainTimeRecordNum);
			unselectItem();
		} else {
			gTTP->NarrowMode = -1;
		}
		gTTP->NLines++;
		gTTP->TableY = gTTP->TopY;
	}
	drawTable();
	drawTime(true);
	*/
}

